//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <vcl\dstring.h>
#include "Unit1.h"
#include "fLayers.h"
#include "Unit2.h"
#include "Unit3.h"
#include "fSHX.h"
#include "fPaths.h"
#include <Math.h>
#include <Windows.hpp>
#include <SGExport.hpp>
#include <DXFImage.hpp>
#include <ShellAPI.hpp>
#include <Printers.hpp>
                  
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SGImage"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
int Start;

struct tagRECTANGLEAROUND {
    TFRect Box;
    int PaperSpace;
} TRectangleAround;

TFPoint GetRealPointUsingsgImagePoint(TsgImage * AsgImage, int X, int Y)
{
  TRect vRect;
  TFPoint res;
  TsgDXFImage * vImg;
  int W, H, L, T;
  bool bMore;

  if (AsgImage->Picture->Graphic->InheritsFrom(__classid(TsgDXFImage)))
  {
    vRect = AsgImage->PictureRect();
    vImg = dynamic_cast<TsgDXFImage *>(AsgImage->Picture->Graphic);
    W = vRect.Right - vRect.Left;
    H = vRect.Bottom - vRect.Top;
    L = vRect.Left - AsgImage->Left;
    T = vRect.Top - AsgImage->Top;
    bMore = ((W <= AsgImage->Width) || (H <= AsgImage->Height));
    if (vImg->Converter->IsCrossoverMatrix)
    {
      if (bMore)
        res = vImg->GetCADCoords(float(X) / W, (AsgImage->Height - Y) / float(H));
      else
        res = vImg->GetCADCoords(float(-L + X) / W, 1 - (Y - T) / float(H));
    }
    else
    {
      if (bMore)
        res = vImg->GetCADCoords(float(X) / W, Y / float(H));
      else
        res = vImg->GetCADCoords(float(-L + X) / W, (Y - T) / float(H));
    }
  }
  else
    res = MakeFPoint(0, 0, 0);
  return res;
}
//---------------------------------------------------------------------------

//#pragma option push -b-
//enum TSelectionMode = { smNone, smRectangle, smEllipse };
//#pragma option pop
//TSelectionMode FSelectionMode;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
TFPoint PtXMat(TFPoint P, TFMatrix M)
{
  TFPoint P1;
  P1.X = P.X * M[0][0] + P.Y * M[1][0] + P.Z * M[2][0] + M[3][0];
  P1.Y = P.X * M[0][1] + P.Y * M[1][1] + P.Z * M[2][1] + M[3][1];
  P1.Z = P.X * M[0][2] + P.Y * M[1][2] + P.Z * M[2][2] + M[3][2];
  return P1;
}

bool TForm1::CreateLines(int D, int AWidth, int AHeight)
{
  int I;
  int dx, dy;

  if (FIntPoints == NULL)
    FIntPoints = new TList;
  else
    FIntPoints->Clear();
  if (D <= 0)
    D = 1;
  dx = D;
  dy = D;
  for(I = 0;I*dx <= AWidth;I++)
  {
    FIntPoints->Add((void *)(I * dx));
    FIntPoints->Add(NULL);
    FIntPoints->Add((void *)(I * dx));
    FIntPoints->Add((void *)(AHeight));
  }
  for(I = 0; I*dy <= AHeight; I++)
  {
    FIntPoints->Add(NULL);
    FIntPoints->Add((void *)(I * dy));
    FIntPoints->Add((void *)(AWidth));
    FIntPoints->Add((void *)(I * dy));
  }
  if (FIntPoints->Count < 2)
    return false;
  else
    return true;
}

void TForm1::DrawPolyPolyLine(HDC DC)
{
  int C;
  unsigned long I, N;
  unsigned long *P;
  N = FIntPoints->Count >> 2;
  if (N == 0)
    return;
  C = FIntPoints->Count;
  for(I = 0; I < N; I++)
    FIntPoints->Add((void *)2);
  P = (unsigned long *)FIntPoints->List;
  P = P + C;
  PolyPolyline(DC,
    (tagPOINT *)FIntPoints->List,
    P,
    N);
  //PolyPolyline(
}

void TForm1::LoadOptions(void)
{
   if (!FOptions)
   {
    FOptions = new TIniFile(ExtractFilePath(Application->ExeName) + sSettings);
   }
   bUseSHXFonts = FOptions->ReadBool(sGeneral, sUseSHX, bUseSHXFonts);
   sSHXSearchPaths = FOptions->ReadString(sGeneral, sSHXPaths, sSHXSearchPaths);
   sDefaultSHXPath = FOptions->ReadString(sGeneral, sSHXPath, sDefaultSHXPath);
   sDefaultSHXFont = FOptions->ReadString(sGeneral, sSHXFont, sDefaultSHXFont);
}
//---------------------------------------------------------------------------

void TForm1::LoadStructure(void)
{
  AnsiString S_LStructure;
  ProgressBar1->Position = 0;
  ProgressBar1->Max = FImg->Converter->Count();
  Panel1->Caption = S_LStructure;
  Panel1->Update();
  TreeView1->Items->BeginUpdate();
  try
  {
    for (int i = 0; i < FImg->Converter->Main->Count; i++)
      AddTree(NULL, FImg->Converter->Main->Entities[i]);
  }
  __finally
  {
    ProgressBar1->Position = 0;
    TreeView1->Items->EndUpdate();
  }
}


void TForm1::Time(void)
{
  int T = (GetCurrentTime() - Start) / 1000;
  TVarRec v[] = {T / 60, T % 60};
  Panel3->Caption = Format("%.2d:%.2d", v, ARRAYSIZE(v) - 1);
  Panel3->Update();
}


void TForm1::EnableScales(void)
{
  for (int i = 3; i < MIScale->Count; i++)
    MIScale->Items[i]->Enabled = !sgPaintBox->Empty();
  MIPrint->Enabled = MIx2->Enabled;
  BtnSave->Enabled = MIx2->Enabled;
  BtnPrint->Enabled = MIx2->Enabled;
  BtnPlus->Enabled = MIx2->Enabled;
  BtnMinus->Enabled = MIx2->Enabled;
  BtnReal->Enabled = MIx2->Enabled;
  btnFitToScreen->Enabled = MIx2->Enabled;
  mmiFindText->Enabled = MIx2->Enabled;
  mmiShowPoint->Enabled = MIx2->Enabled;
  sbShowBorder->Enabled = MIx2->Enabled;
}

void TForm1::Open(AnsiString FileName)
{

  if (FileName == "") return;
  TsgDXFImage *sgDXFImage = NULL;
  Start = GetCurrentTime();
  Screen->Cursor = crHourGlass;
  Orbit3D->Visible = false;
  try
  {
    ProgressBar1->Visible = true;
    sgPaintBox->LoadFromFile(FileName);
    Graphics::TBitmap *Bmp = dynamic_cast<Graphics::TBitmap *>(sgPaintBox->Picture->Graphic);
    if (Bmp) sgPaintBox->Picture->Bitmap->HandleType = bmDDB;
    MIClose->Enabled = true;
    Panel1->Caption = UpperCase(ExtractFileName(FileName));
    EnableScales();
    HelpContext = 3;
    MIAutoClick(NULL);
    sgDXFImage = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
    if (sgDXFImage == NULL)
    {
      pnlLayouts->Visible = false;
      ProgressBar1->Position = 0;
      Screen->Cursor = crDefault;
      btnLayers->Enabled = false;
      miSaveAs->Enabled = false;
      SetBtnEnable(FImg != NULL);
      return;
    }
    FImg = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
    ViewLayouts();
    sgPaintBox->ScaleMMWidth = FImg->AbsWidth();
    SetImgOpt();
    TabSheet2->TabVisible = true;
    LoadStructure();
    Panel1->Caption = UpperCase(ExtractFileName(FileName));
    MIPrint->Enabled = true;
    MiOEM->Enabled = true;
    MiOEM->Checked = !FImg->Converter->OEM();
    MiOEMClick(NULL);
  }
  __finally
  {
    SetBtnEnable(FImg != NULL);
    pnlLayouts->Visible = FImg != NULL;
    Orbit3D->Visible = false;
    ProgressBar1->Position = 0;
    Screen->Cursor = crDefault;
    miSaveAs->Enabled = (sgDXFImage != NULL);
    btnLayers->Enabled = (sgDXFImage != NULL);
    sbShowBorder->Enabled = (sgDXFImage != NULL);
    sb3DAxes->Down = false;
    ProgressBar1->Visible = false;
  }
}

void TForm1::AddTree(TTreeNode * Parent, TsgDXFEntity * E)
{
    Parent = TreeView1->Items->AddChildObject(Parent, E->EntName(), E);
    Application->ProcessMessages();
    ProgressBar1->Position =+ 1;
    for (int i = 0; i < E->Count; i++) AddTree(Parent, E->Entities[i]);
}

void __fastcall TForm1::MIAutoClick(TObject *Sender)
{
  sgPaintBoxScaling(NULL);
  sgPaintBox->Align = alClient;
  MIAuto->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sgPaintBoxScaling(TObject *Sender)
{
  sgPaintBox->Align = alNone;
  MIx2->Checked = true;
  MIx2->Checked = false;
  MIAuto->Enabled = true;
  BtnReal->Enabled = true;
  MIPrev->Enabled = sgPaintBox->HasPrevScale();
  BtnPrev->Enabled = MIPrev->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MiOEMClick(TObject *Sender)
{
  MiOEM->Checked = !MiOEM->Checked;
  if (FImg == NULL) return;
  if (MiOEM->Checked)
    FImg->Charset = OEM_CHARSET;
  else
    FImg->Charset = DEFAULT_CHARSET;
  ListBox1->Font->Charset = FImg->Charset;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SoftGoldHomePage1Click(TObject *Sender)
{
  ShellExecute(Handle, "open", "www.cadsofttools.com", "", "", SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIAboutClick(TObject *Sender)
{
  ShowMessage("DWG/DXF VCLs demo version \nPlease contact www.cadsofttools.com to order a full version");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //sgPaintBox = new TsgImage(this);
  //sgPaintBox->Parent = ScrollBox1;
  //sgPaintBox->ManualDock(ScrollBox1);
  sgPaintBox->Align = alClient;
  sgPaintBox->Align = alNone;
  LoadOptions();
  OpenDialog1->Filter = GraphicFilter(__classid(TGraphic));
  Orbit3D = new TsgOrbit3D(this);
  Orbit3D->Drawing = sgPaintBox;
  Orbit3D->Parent = ScrollBox1;
  Orbit3D->Visible = false;
  pnlLayouts->Visible = false;

  if (ParamCount > 0)
  {
    Open(ParamStr(1));
    OpenDialog1->FileName = ParamStr(1);
  }
  ProgressBar1->Align = alClient;
  ProgressBar1->Visible = false;
}
//---------------------------------------------------------------------------


void TForm1::Scroll(TShiftState Shift, bool Both, WORD Msg, WORD Code1,
  WORD Code2)
{
  if (Shift.Contains(ssCtrl)) Code1 = Code2;
  SendMessage(ScrollBox1->Handle, Msg, Code1, 0);
  if ((Both) && (Shift.Contains(ssCtrl)))
    SendMessage(ScrollBox1->Handle, WM_VSCROLL, Code1, 0);
}
void __fastcall TForm1::MICloseClick(TObject *Sender)
{
  ListBox1->Clear();
  TreeView1->Items->Clear();
  sgPaintBox->Picture->Graphic = NULL;
  FImg = NULL;
  Panel1->Caption = "";
  Panel3->Caption = "";
  MIClose->Enabled = false;
  MIPrint->Enabled = false;
  MiOEM->Enabled = false;
  BtnSave->Enabled = false;
  PageControl1->ActivePage = TabSheet1;
  TabSheet2->TabVisible = false;
  EnableScales();
  sgPaintBox->Align = alNone;
  sgPaintBox->SetBounds(0,0,0,0);
  ProgressBar1->Max = 100;
  HelpContext = 1;
  SetBtnEnable(FImg != NULL);
  Enable3DOrbit(false);
  pnlLayouts->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIOpenClick(TObject *Sender)
{
  if (!OpenDialog1->Execute()) return;
  MICloseClick(NULL);
  Open(OpenDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::miSaveAsClick(TObject *Sender)
{
  char *vFileName = StrNew("");
  Graphics::TBitmap *vBmp = new Graphics::TBitmap();

  if ((sgPaintBox->Empty()) || (!SavePictureDialog->Execute())) return;
  if (LowerCase(ExtractFileExt(SavePictureDialog->FileName)) == ".wmf")
  {
    TMetafile *vM = new TMetafile;
    try
    {
      vM->Width = sgPaintBox->Width;
      vM->Height = sgPaintBox->Height;
      TMetafileCanvas *vMC = new TMetafileCanvas(vM, 0);
      try
      {
        vMC->StretchDraw(sgPaintBox->ClientRect, sgPaintBox->Picture->Graphic);
      }
      __finally
      {
        delete vMC;
      }
      vM->SaveToFile(SavePictureDialog->FileName);
    }
    __finally
    {
      delete vM;
    }
    return;
  }

  if (((LowerCase(ExtractFileExt(SavePictureDialog->FileName)) == ".bmp")||
    (LowerCase(ExtractFileExt(SavePictureDialog->FileName)) == ""))&&(sbShowBorder->Down))
  {
    try
    {
      vBmp->Width = sgPaintBox->Width;
      vBmp->Height = sgPaintBox->Height;
      vBmp->Assign(sgPaintBox->Picture->Graphic);
      vBmp->Canvas->StretchDraw(Rect(0, 0, sgPaintBox->Width, sgPaintBox->Height),
        imgFrame->Picture->Bitmap);
      vFileName = "abviewer.tmp";
      vFileName = StrPCopy(vFileName, ExtractFileName(SavePictureDialog->FileName));
      if (ExtractFileExt(SavePictureDialog->FileName) != ".bmp")
        vFileName = StrCat(vFileName, ".bmp");
      vBmp->SaveToFile(vFileName);
    }
    __finally
    {
      delete vBmp;
    }
    return;
  }
  TsgExport *E = new TsgExport;
  try
  {
    vFileName = "abviewer.tmp";
    vFileName = StrPCopy(vFileName, ExtractFileName(SavePictureDialog->FileName));
    if (ExtractFileExt(SavePictureDialog->FileName) != ".bmp")
      vFileName = StrCat(vFileName, ".bmp");
    E->ExportTo(sgPaintBox->Picture->Graphic, vFileName,
      Sgexport::TsgExportFormat(SavePictureDialog->FilterIndex - 1), sgPaintBox->Width,
      sgPaintBox->Height);
  }
  __finally
  {
    delete E;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIPrintClick(TObject *Sender)
{
  if (sgPaintBox->Width > sgPaintBox->Height)
    Printer()->Orientation = poLandscape;
  else
    Printer()->Orientation = poPortrait;
  if (PrintDialog1->Execute())
  {
    double W = Printer()->PageWidth / sgPaintBox->Picture->Width;
    double H = Printer()->PageHeight / sgPaintBox->Picture->Height;
    if (W > H) W = H;
    int PW = W * sgPaintBox->Picture->Width;
    int PH = W * sgPaintBox->Picture->Height;
    Printer()->BeginDoc();
    Printer()->Canvas->StretchDraw(Bounds((Printer()->PageWidth - PW) / 2,
      (Printer()->PageHeight - PH) / 2, PW, PH), sgPaintBox->Picture->Graphic);
    Printer()->EndDoc();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIPrevClick(TObject *Sender)
{
  sgPaintBox->PrevScale();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIx2Click(TObject *Sender)
{
  if (Sender == BtnReal) Sender = MIx1;
  sgPaintBox->ChangeScale(true, ((TComponent *)Sender)->Tag / 100.0,
    sgPaintBox->Center());
  ((TMenuItem *)Sender)->Checked = true;
  BtnReal->Enabled = !MIx1->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Disabled1Click(TObject *Sender)
{
  TsgDXFImage *sgDXFImage = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
  if ((sgPaintBox->Empty()) || (sgDXFImage == NULL)) return;
  ((TsgDXFImage *)sgPaintBox->Picture->Graphic)->DrawMode = dmGray;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Black1Click(TObject *Sender)
{
  TsgDXFImage *sgDXFImage = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
  if ((sgPaintBox->Empty()) || (sgDXFImage == NULL)) return;
  ((TsgDXFImage *)sgPaintBox->Picture->Graphic)->DrawMode = dmBlack;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Normal1Click(TObject *Sender)
{
  TsgDXFImage *sgDXFImage = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
  if ((sgPaintBox->Empty()) || (sgDXFImage == NULL)) return;
  ((TsgDXFImage *)sgPaintBox->Picture->Graphic)->DrawMode = dmNormal;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TreeView1Change(TObject *Sender, TTreeNode *Node)
{
  if (!Node->Selected) return;
  TsgDXFEntity *E = ((TsgDXFEntity *)Node->Data);
  if (E == NULL)
    ListBox1->Clear();
  else
    if ((E->SrcStart == NULL) || (E->SrcEnd == NULL))
      ListBox1->Clear();
    else
    {
      AnsiString S = AnsiString(E->SrcStart, E->SrcEnd - E->SrcStart);
      ListBox1->Items->Text = S;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  sgPaintBox->Cancel();
  if (Key == VK_ESCAPE) Close();
  if (sgPaintBox->Empty()) return;
  if ((PageControl1->ActivePage != TabSheet1) || (!Shift.Contains(ssCtrl))) return;
  switch (Key){
    case VK_ADD:
      BtnPlusClick(NULL);
      break;
    case VK_SUBTRACT:
      BtnMinusClick(NULL);
      break;
    case VK_MULTIPLY:
      MIx2Click(BtnReal);
      break;
    case VK_UP:
      Scroll(Shift, false, WM_VSCROLL, SB_LINELEFT, SB_PAGELEFT);
      break;
    case VK_DOWN:
      Scroll(Shift, false, WM_VSCROLL, SB_LINERIGHT, SB_PAGERIGHT);
      break;
    case VK_PRIOR:
      Scroll(Shift, false, WM_VSCROLL, SB_PAGELEFT, SB_TOP);
      break;
    case VK_NEXT:
      Scroll(Shift, false, WM_VSCROLL, SB_PAGERIGHT, SB_BOTTOM);
      break;
    case VK_LEFT:
      Scroll(Shift, false, WM_HSCROLL, SB_LINELEFT, SB_PAGELEFT);
      break;
    case VK_RIGHT:
      Scroll(Shift, false, WM_HSCROLL, SB_LINERIGHT, SB_PAGERIGHT);
      break;
    case VK_HOME:
      Scroll(Shift, true, WM_HSCROLL, SB_TOP, SB_TOP);
      break;
    case VK_END:
      Scroll(Shift, true, WM_HSCROLL, SB_BOTTOM, SB_BOTTOM);
      break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnPlusClick(TObject *Sender)
{
  sgPaintBox->ChangeScale(false, 2, sgPaintBox->Center());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnMinusClick(TObject *Sender)
{
  sgPaintBox->ChangeScale(false, 0.5, sgPaintBox->Center());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sgPaintBoxProgress(TObject *Sender,
      TProgressStage Stage, BYTE PercentDone, bool RedrawNow,
      const TRect &R, const AnsiString Msg)
{
  if (Stage == psStarting)
  {
    Panel1->Caption = Msg;
    Panel1->Update();
  }
  ProgressBar1->Position = PercentDone;
  Time();
  if (Stage == psEnding)
  {
    ProgressBar1->Position = 0;
    Panel1->Caption = UpperCase(ExtractFileName(OpenDialog1->FileName));
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBox1Resize(TObject *Sender)
{
  if (!sgPaintBox->Empty()) sgPaintBox->SetBounds(sgPaintBox->Left,
    sgPaintBox->Top, sgPaintBox->Width, sgPaintBox->Height);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PageControl1Changing(TObject *Sender,
      bool &AllowChange)
{
  AllowChange = FImg != NULL;
  FocusControl(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if (cbLayouts->DroppedDown) return;
  if ((sgPaintBox->Empty()) || (PageControl1->ActivePage != TabSheet1)) return;
  MousePos = ScrollBox1->ScreenToClient(MousePos);
  sgPaintBox->ChangeScale(false, 0.8, MousePos);
  Handled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if (cbLayouts->DroppedDown) return;
  if ((sgPaintBox->Empty()) || (PageControl1->ActivePage != TabSheet1)) return;
  MousePos = ScrollBox1->ScreenToClient(MousePos);
  sgPaintBox->ChangeScale(false, 1.2, MousePos);
  Handled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLayersClick(TObject *Sender)
{
  if (FImg == NULL) return;
  LayersDialogExecute(FImg, sgPaintBox);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sgPaintBoxPaint(TObject *Sender)
{
  TFRect vExt;
  POINT vLeftTop, vRightBottom;
  int vRectLeft, vRectTop;

  Graphics::TBitmap *vBmp = new Graphics::TBitmap();
  try
  {
    if ((FImg != NULL)&&(sbShowBorder->Enabled)&&(sbShowBorder->Down))
    {
      vBmp->PixelFormat = pf8bit;
      vBmp->Width = sgPaintBox->Width;
      vBmp->Height = sgPaintBox->Height;
      vBmp->Assign(imgFrame->Picture->Bitmap);
      vBmp->Transparent = true;
      sgPaintBox->Canvas->StretchDraw(Rect(0, 0, sgPaintBox->Width, sgPaintBox->Height),
        vBmp);
    }
  }
  __finally
  {
    delete vBmp;
  }

  if ((FImg)&&(!FImg->Empty)&&(FSelectionMode == 2))
  {
    vExt = FImg->Extents;
    if (sgPaintBox->UsePictureRect())
    {
      vRectLeft = sgPaintBox->PictureRect().Left - sgPaintBox->Left;
      vRectTop = sgPaintBox->PictureRect().Top - sgPaintBox->Top;
      vLeftTop.x = ceil((sgPaintBox->PictureRect().Right - sgPaintBox->PictureRect().Left) * (FTextBox.Left - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vLeftTop.y = ceil((sgPaintBox->PictureRect().Bottom - sgPaintBox->PictureRect().Top) * (1 - (FTextBox.Top - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
      vRightBottom.x = ceil((sgPaintBox->PictureRect().Right - sgPaintBox->PictureRect().Left) *  (FTextBox.Right - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vRightBottom.y = ceil((sgPaintBox->PictureRect().Bottom - sgPaintBox->PictureRect().Top) * (1 - (FTextBox.Bottom - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
    }
    else
    {
      vRectLeft = 0;
      vRectTop = 0;
      vLeftTop.x = ceil(sgPaintBox->Width * (FTextBox.Left - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vLeftTop.y = ceil(sgPaintBox->Height * (1 - (FTextBox.Top - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
      vRightBottom.x = ceil(sgPaintBox->Width *  (FTextBox.Right - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vRightBottom.y = ceil(sgPaintBox->Height * (1 - (FTextBox.Bottom - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
    }
    sgPaintBox->Canvas->Pen->Color = clRed;
    sgPaintBox->Canvas->Brush->Style = bsClear;
    sgPaintBox->Canvas->Ellipse(vLeftTop.x - 10, vLeftTop.y - 10, vRightBottom.x + 10, vRightBottom.y + 10);
  }


  if (sbDrid->Down)
  {
    if ((FImg != NULL)&&(!(FImg->Empty)))
    {
      vExt = FImg->Extents;
      if (CreateLines(ceil(FImg->AbsWidth()*FImg->Scale.X/speGridCount->Value),
        ceil(FImg->AbsWidth()*FImg->Scale.X),
        ceil(FImg->AbsHeight()*FImg->Scale.Y)))
      {
        sgPaintBox->Canvas->Pen->Color = clGray;
        DrawPolyPolyLine(sgPaintBox->Canvas->Handle);
      }
    }
  }

  if (Orbit3D->Visible) Orbit3D->Paint();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnIsWithoutBorderClick(TObject *Sender)
{
  if (FImg != NULL) FImg->IsWithoutBorder = !FImg->IsWithoutBorder;
}
//---------------------------------------------------------------------------


void TForm1::SetImgOpt(void)
{
  btnShowLineWeightClick(NULL);
  btnSplittedArcClick(NULL);
  btnDrawAllColorClick(NULL);
  btnWhiteBackgroundClick(NULL);
  SetPnlSizeCaption();
}

void TForm1::SetPnlSizeCaption(void)
{
  TsgDXFImage *vImg;
  #ifndef sgDXFONLY
  TsgHPGLImage *vHPGLImg;
  #endif
  if (!sgPaintBox->Empty())
  {
    #ifndef sgDXFONLY
    if (sgPaintBox->Picture->Graphic->ClassType() == __classid(TsgHPGLImage))
    {
      vHPGLImg = (TsgHPGLImage *)(sgPaintBox->Picture->Graphic);
      TVarRec v1[] = {vHPGLImg->MMWidth / 100.0, vHPGLImg->MMHeight / 100.0};
      pnlSize->Caption = Format("%.3f mm x %.3f mm", v1, 1);
    }
    else
    #endif
      if (sgPaintBox->Picture->Graphic->InheritsFrom(__classid(TsgDXFImage)))
      {
        vImg = (TsgDXFImage *)(sgPaintBox->Picture->Graphic);
        TVarRec v[] = {vImg->AbsWidth(), vImg->AbsHeight()};
        if (vImg->CurrentLayout->PlotSettings.PlotPaperUnits == 0)
          pnlSize->Caption = Format("%.3f in x %.3f in", v, 1);
        else
          pnlSize->Caption = Format("%.3f mm x %.3f mm", v, 1);
      }
  }
}

void __fastcall TForm1::btnFitToScreenClick(TObject *Sender)
{
  sgPaintBox->Align = alNone;
  sgPaintBox->Align = alClient;
  sgPaintBoxScaling(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnDrawAllColorClick(TObject *Sender)
{
  if (btnDrawAllColor->Down)
    FImg->DrawMode = dmNormal;
  else
    FImg->DrawMode = dmBlack;

}
//---------------------------------------------------------------------------



void __fastcall TForm1::btnWhiteBackgroundClick(TObject *Sender)
{
  if (btnWhiteBackground->Down)
  {
    FImg->BackgroundColor = clWhite;
    FImg->DefaultColor = clBlack;
  }
  else
  {
    FImg->BackgroundColor = clBlack;
    FImg->DefaultColor = clWhite;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnShowLineWeightClick(TObject *Sender)
{
  FImg->IsShowLineWeight = btnShowLineWeight->Down;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSplittedArcClick(TObject *Sender)
{
  FImg->UseWinEllipse = !btnSplittedArc->Down;
}
//---------------------------------------------------------------------------


void TForm1::SetBtnEnable(bool AEnable)
{
  for (int i = 0; i <= ComponentCount - 1; i++)
    if ((Components[i]->ClassNameIs("TSpeedButton")) && (Components[i]->Tag == 1) )
      ((TSpeedButton *)Components[i])->Enabled = AEnable;
}


void TForm1::ViewLayouts()
{
  cbLayouts->Items->Clear();
  if (FImg)
  {
    for (int I = 0; I < FImg->LayoutsCount; I++)
      cbLayouts->Items->AddObject(FImg->Layouts[I]->Name, FImg->Layouts[I]);
    cbLayouts->ItemIndex = FImg->Converter->DefaultLayoutIndex;
    FImg->CurrentLayout = FImg->Layouts[cbLayouts->ItemIndex];
    pnlLayouts->Visible = true;
  }
}

void TForm1::Enable3DAxes(bool AIsEnabled)
{
  sb3DAxes->Down = false;
  sb3DAxes->Enabled = AIsEnabled;
  FImg->IsDraw3DAxes = sb3DAxes->Down;
}


void TForm1::Enable3DOrbit(bool AIsEnabled)
{
  if (Orbit3D) Orbit3D->Visible = false;
  sb3DOrbit->Down = false;
  sb3DOrbit->Enabled = AIsEnabled;
}

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete Orbit3D;
  Orbit3D = NULL;
  delete FIntPoints;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb3DOrbitClick(TObject *Sender)
{
  sb3DOrbit->Down = sb3DOrbit->Down | false;
  if (sb3DOrbit->Down)
  {
    Orbit3D->CADImage = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
    Orbit3D->Visible = true;
    Orbit3D->Parent->Repaint();
  }
  else
  {
    Orbit3D->CADImage = NULL;
    Orbit3D->Visible = false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cbLayoutsChange(TObject *Sender)
{
  if (cbLayouts->Items->Objects[cbLayouts->ItemIndex])
  {
    FImg->CurrentLayout = FImg->Layouts[cbLayouts->ItemIndex];
    sgPaintBox->Width = FImg->Width;
    sgPaintBox->Height = FImg->Height;
    sgPaintBox->Align = alClient;
    sgPaintBox->Invalidate();
  }
  if (FImg)
  {
    Enable3DAxes(FImg->CurrentLayout->CADSpace != csUndefined);
    Enable3DOrbit(FImg->CurrentLayout->CADSpace != csUndefined);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb3DAxesClick(TObject *Sender)
{
  sb3DAxes->Down = sb3DAxes->Down | false;
  if (sb3DAxes->Down)
    FImg->IsDraw3DAxes = true;
  else
    FImg->IsDraw3DAxes = false;
  sgPaintBox->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  if (Orbit3D)
    if (Orbit3D->Visible)
      Orbit3D->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::speNumPartsCircleChange(TObject *Sender)
{
  int Val = speNumPartsCircle->Value;
  if (Val >= 2)
  {
    FImg->Converter->NumberOfPartsInCircle = Val;
    sgPaintBox->Invalidate();
  }
  else
    speNumPartsCircle->Value = 2;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::speNumPartsSplineChange(TObject *Sender)
{
  int Val = speNumPartsSpline->Value;
  if (Val >= 1)
  {
    FImg->Converter->NumberOfPartsInSpline = Val;
    sgPaintBox->Invalidate();
  }
  else
    speNumPartsSpline->Value = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sbShowBorderClick(TObject *Sender)
{
  sbShowBorder->Down = sbShowBorder->Down | false;
  sgPaintBox->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sbShowSHXFontsClick(TObject *Sender)
{
  SHXOptionsExecute(FOptions, Form1);
  sgPaintBox->Invalidate();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::sbDridClick(TObject *Sender)
{
  sgPaintBox->Invalidate();
  sgPaintBox->Transparent = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::speGridCountChange(TObject *Sender)
{
  sgPaintBox->Invalidate();
}
//---------------------------------------------------------------------------

void TForm1::ActualGraphic(TMetafile *vResult)
{
  TMetafileCanvas *vMC;
  TRect vRect, vBoundRect, imgRectangle;
  HDC hDc;
  HRGN vRGN;
  TOSVersionInfo OSVersionInfo;
  double mmToPixelX, mmToPixelY;

  imgRectangle = ScrollBox1->ClientRect;

  hDc = GetDC(0);
  try
  {
    double hs = GetDeviceCaps(hDc,HORZSIZE);
    double hr = GetDeviceCaps(hDc,HORZRES);
    mmToPixelX = hs/hr;
    hs = GetDeviceCaps(hDc,VERTSIZE);
    hr = GetDeviceCaps(hDc,VERTRES);
    mmToPixelY = hs/hr;
  }
  __finally
  {
    ReleaseDC(Handle, hDc);
  }

  vRect = sgPaintBox->PictureRect();
  vRect.Left = vRect.Left - imgRectangle.Left;
  vRect.Top = vRect.Top - imgRectangle.Top;
  vRect.Right = vRect.Right - imgRectangle.Left;
  vRect.Bottom = vRect.Bottom - imgRectangle.Top;

  OSVersionInfo.dwOSVersionInfoSize = sizeof(TOSVersionInfo);
  GetVersionEx(&OSVersionInfo);
  if (OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT)
  {
    vResult->MMWidth = (int)((imgRectangle.Right - imgRectangle.Left) * 1000 * mmToPixelX);
    vResult->MMHeight = (int)((imgRectangle.Bottom - imgRectangle.Top) * 1000 * mmToPixelY);
    vRect.Left = vRect.Left * 10;
    vRect.Top = vRect.Top * 10;
    vRect.Right = vRect.Right * 10;
    vRect.Bottom = vRect.Bottom * 10;
  }
  else // win9x
  {
    vResult->MMWidth = (int)((imgRectangle.Right - imgRectangle.Left) * 500 * mmToPixelX);
    vResult->MMHeight = (int)((imgRectangle.Bottom - imgRectangle.Top) * 500 * mmToPixelY);
    vRect.Left = vRect.Left * 5;
    vRect.Top = vRect.Top * 5;
    vRect.Right = vRect.Right * 5;
    vRect.Bottom = vRect.Bottom * 5;
  }
  vMC = new TMetafileCanvas(vResult, 0);
  try
  {
    if (OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT)
      vRGN = CreateRectRgn(0, 0, (imgRectangle.Right - imgRectangle.Left) * 10, (imgRectangle.Bottom - imgRectangle.Top) * 10);
    else
      vRGN = CreateRectRgn(0, 0, (imgRectangle.Right - imgRectangle.Left) * 5, (imgRectangle.Bottom - imgRectangle.Top) * 5);

    SelectClipRgn(vMC->Handle, vRGN);
    vMC->StretchDraw(vRect, sgPaintBox->Picture->Graphic);
    DeleteObject(vRGN);
  }
  __finally
  {
    delete vMC;
    if (FImg != NULL)
      FImg->IsShowBackground = True;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnPrint2Click(TObject *Sender)
{
  POINT P;

  Win32Check(::GetCursorPos(&P));
  pmPrint->Popup((int)P.x, (int)P.y);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::pmiPrinrerClick(TObject *Sender)
{
  double W,H;
  int PW,PH;
  TMetafile *vGr;

  if (sgPaintBox->Picture != NULL)
  {
    if (sgPaintBox->Picture->Width > sgPaintBox->Picture->Height)
      Printer()->Orientation = poLandscape;
    else Printer()->Orientation = poPortrait;
  }
  if (PrintDialog1->Execute())
  {
    vGr = new TMetafile;
    try
    {
      ActualGraphic(vGr);
      W = (double)Printer()->PageWidth / (double)vGr->Width;
      H = (double)Printer()->PageHeight / (double)vGr->Height;
      if (W > H)
       W = H;
      PW = (int)(W * vGr->Width);
      PH = (int)(W * vGr->Height);
      Printer()->BeginDoc();
      Printer()->Canvas->StretchDraw(Bounds((Printer()->PageWidth-PW) / 2, (Printer()->PageHeight-PH) / 2, PW, PH), vGr);
      Printer()->EndDoc();
    }
    __finally
    {
     delete vGr;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::pmiMetafileClick(TObject *Sender)
{
  TMetafile *vGr;

  SavePictureDialog->FilterIndex = 3;
  if ((sgPaintBox->Empty()) || (!SavePictureDialog->Execute()))
   return;
  vGr = new TMetafile;
  try
  {
    ActualGraphic(vGr);
    if (LowerCase(ExtractFileExt(SavePictureDialog->FileName)) == "")
      vGr->SaveToFile(SavePictureDialog->FileName+".emf");
    else
      vGr->SaveToFile(SavePictureDialog->FileName);
  }
  __finally
  {
    delete vGr;
  }
}
//---------------------------------------------------------------------------

TsgDXFEntity * TForm1::AddRectToConv(TFRect ABox)
{
  TsgDXFVertex *Vertex;
  TsgDXFPolyline *vPoly;

  vPoly = new TsgDXFPolyline;
  Vertex = new TsgDXFVertex;
  Vertex->Point = ABox.TopLeft;
  vPoly->AddEntity(Vertex);
  Vertex = new TsgDXFVertex;
  Vertex->Point = MakeFPoint(ABox.BottomRight.X, ABox.TopLeft.Y, ABox.TopLeft.Z);
  vPoly->AddEntity(Vertex);
  Vertex = new TsgDXFVertex;
  Vertex->Point = ABox.BottomRight;
  vPoly->AddEntity(Vertex);
  Vertex = new TsgDXFVertex;
  Vertex->Point = MakeFPoint(ABox.TopLeft.X, ABox.BottomRight.Y, ABox.BottomRight.Z);
  vPoly->AddEntity(Vertex);
  vPoly->SetColor(clRed);
  vPoly->SetLWeight(1);
  vPoly->Closed = true;
  return ((TsgDXFEntity *)vPoly);
}
//---------------------------------------------------------------------------

void TForm1::SelectEntities(void)
{
  int I;
  TsgDXFEntity *Ent;
  TsgDXFImage *Im;
  tagRECTANGLEAROUND *vRect;

  for(I = 0; I < FSelectedEntities->Count; I++)
  {
    vRect = (tagRECTANGLEAROUND *)(FSelectedEntities->Items[I]);

    Ent = AddRectToConv(vRect->Box);
    if (Ent)
    {
      Im = dynamic_cast<TsgDXFImage *>(sgPaintBox->Picture->Graphic);
      Im->Converter->Sections[csEntities]->AddEntity(Ent);
      if (Im->Converter->OnCreate != NULL)
        Im->Converter->OnCreate(Ent);
      Im->Converter->Loads(Ent);
      Ent->PaperSpace = vRect->PaperSpace;
      sgPaintBox->Invalidate();
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReadCADEntities(TsgDXFEntity *Entity)
{
  long double vScale;
  AnsiString S1, S2;
  double mmToPixelX;
  tagRECTANGLEAROUND *vRectAround;
  TFPoint P;
  TsgDXFAttrib *CurAttrib;
  TFRect vBox;
  bool vAttribFlag;

  if (FFindFlag)
    return;

  if((Entity->ClassType() == __classid(TsgDXFAttrib))||
     (Entity->ClassType() == __classid(TsgDXFMText))||
     (Entity->ClassType() == __classid(TsgDXFText)))
  {
    FTextPoint = ((TsgDXFAttrib *)Entity)->Point;
    if (Entity->ClassType() == __classid(TsgDXFMText))
    {
      //FTextPoint = ((TsgDXFMText *)Entity)->Point;
    }
    S1 = AnsiUpperCase(FSearchingText);
    S2 = AnsiUpperCase(((TsgDXFText *)(Entity))->Text);
    vAttribFlag = false;
    memset(&vBox, sizeof(TFRect), 0);
    if (FCADParams.Insert != NULL)
    {
      P = PtXMat(((TsgDXFText *)(Entity))->StartPoint, FCADParams.Matrix);
      CurAttrib = FCADParams.Insert->Attrib(S2, P);
      if (CurAttrib)
      {
        S2 = CurAttrib->Text;
        vBox = CurAttrib->Box;
        vAttribFlag = true;
      }
    }
    if (StrComp(S1.c_str(), S2.c_str()) == 0)
    {
      FSearchResult = true;
      FTextPoint = PtXMat(((TsgDXFText *)(Entity))->StartPoint, FCADParams.Matrix);
      mmToPixelX = GetDeviceCaps(GetDC(0),HORZSIZE);
      mmToPixelX /= GetDeviceCaps(GetDC(0),HORZRES);
      FTextBox.TopLeft = PtXMat(((TsgDXFText *)(Entity))->Box.TopLeft, FCADParams.Matrix);
      FTextBox.BottomRight = PtXMat(((TsgDXFText *)(Entity))->Box.BottomRight, FCADParams.Matrix);
      vScale = (mmToPixelX * sgPaintBox->Parent->Height) /
         fabs(FTextBox.TopLeft.Y - FTextBox.BottomRight.Y) * 5.0;
      sgPaintBox->ScaleMMWidth = FImg->AbsWidth();
      sgPaintBox->Align = alNone;
      sgPaintBox->ShowPoint(FTextPoint, vScale, FImg->Extents);
      if (!FSearchModeIsAll)
        FFindFlag = true;
      if (FSelectionMode == 1)//(FSelectionMode = smRectangle)
      {
        vRectAround = new tagRECTANGLEAROUND;
        if (!vAttribFlag)
        {
          vRectAround->Box.TopLeft = PtXMat(Entity->Box.TopLeft, FCADParams.Matrix);
          vRectAround->Box.BottomRight = PtXMat(Entity->Box.BottomRight, FCADParams.Matrix);
        }
        else
          vRectAround->Box = vBox;
        vRectAround->PaperSpace = (int)(FImg->Layouts[0] != FImg->CurrentLayout);
        FSelectedEntities->Add(vRectAround);
      }
    }
  }
}
//---------------------------------------------------------------------------

bool __fastcall TForm1::FindText(AnsiString S, int ASelection, bool ASearch)
{
  int I;

  FSearchingText = S;
  FSelectionMode = ASelection;
  FSearchModeIsAll = ASearch;
  FSearchResult = false;
  memset(FCADParams.Matrix, sizeof(TFMatrix), 0);
  FCADParams.Matrix[0][0] = 1.0;
  FCADParams.Matrix[1][1] = 1.0;
  FCADParams.Matrix[2][2] = 1.0;
  //Matrix = &FCADParams.Matrix[0][0];
  //*Matrix = IdentityMat();
  FImg->Converter->AutoInsert = true; // to get all the elements inside of inserts
  FFindFlag = false;
  FSelectedEntities = new TList;
  try
  {
    FImg->Converter->Iterate((TsgCADEntityProc)(& ReadCADEntities), FCADParams);
    SelectEntities();
  }
  __finally
  {
    for(I = 0; I < FSelectedEntities->Count; I++)
      delete ((tagRECTANGLEAROUND *)FSelectedEntities->Items[I]);
    FSelectedEntities->Free();
  }
  return FSearchResult;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mmiFindTextClick(TObject *Sender)
{
  TForm3 *Form3;

  Form3 = new TForm3(this);
  try
  {
    Form3->ShowModal();
  }
  __finally
  {
    Form3->Free();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sgPaintBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  TFPoint vPt;
  AnsiString S;
  if (!sgPaintBox->Empty())
    if (sgPaintBox->Picture->Graphic->InheritsFrom(__classid(TsgDXFImage)))
    {
      vPt = GetRealPointUsingsgImagePoint(sgPaintBox, X, Y);
      TVarRec v[] = {vPt.X, vPt.Y};
      S = Format("(%.3f; %.3f; 0.000)", v, 1);
      pnlCoords->Caption = S;
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::mmiShowPointClick(TObject *Sender)
{
  TfrmShowPoint *frmShowPoint;

  frmShowPoint = new TfrmShowPoint(this);
  try
  {
    frmShowPoint->ShowModal();
  }
  __finally
  {
    frmShowPoint->Free();
  }
}
//---------------------------------------------------------------------------

