unit fEntity;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DXFConv, sgConsts, Spin;

type
  TfmCreateEntity = class(TForm)
    pnlMain: TPanel;
    Label1: TLabel;
    cbEntity: TComboBox;
    lblColor: TLabel;
    mmCoordinates: TMemo;
    btnOK: TButton;
    btnCancel: TButton;
    pnlColor: TPanel;
    bntColor: TButton;
    ColorDialog1: TColorDialog;
    lblWidth: TLabel;
    seWeight: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure cbEntityChange(Sender: TObject);
    procedure bntColorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function GetEntity: TsgDXFEntity;

implementation

{$R *.DFM}


function GetEntity: TsgDXFEntity;
var
  fmCreateEntity: TfmCreateEntity;
  Dc: Char;
  St: TStrings;
  I: Integer;
  S: string;
  Vertex: TsgDXFVertex;

begin
  Result := nil;
  fmCreateEntity := TfmCreateEntity.Create(Application);
  Dc := DecimalSeparator;
  try
    DecimalSeparator := '.';
    fmCreateEntity.ShowModal;
    if fmCreateEntity.ModalResult = mrOK then
    begin
      St := fmCreateEntity.mmCoordinates.Lines;
      case fmCreateEntity.cbEntity.ItemIndex of
        0:
          begin
            Result := TsgDXFLine.Create;
            TsgDXFLine(Result).Point := MakeFPoint(ConvToFloatDef(St.Values['X1'],
              0.0), ConvToFloatDef(St.Values['Y1'], 0.0),
              ConvToFloatDef(St.Values['Z1'], 0.0));
            TsgDXFLine(Result).Point1 := MakeFPoint(ConvToFloatDef(St.Values['X2'],
              0.0), ConvToFloatDef(St.Values['Y2'], 0.0),
              ConvToFloatDef(St.Values['Z2'], 0.0));
          end;
        1:
          begin
            I := 1;
            S := St.Values['X' + IntToStr(I)];
            Result := TsgDXFPolyline.Create;
            repeat
              Vertex := TsgDXFVertex.Create;
              Vertex.Point := MakeFPoint(ConvToFloatDef(St.Values['X' + IntToStr(I)],
              0.0), ConvToFloatDef(St.Values['Y' + IntToStr(I)], 0.0),
              ConvToFloatDef(St.Values['Z' + IntToStr(I)], 0.0));
              Inc(I);
              S := St.Values['X' + IntToStr(I)];
              Result.AddEntity(Vertex);
            until S = '';
          end;
        2:
          begin
            Result := TsgDXFCircle.Create;
            TsgDXFCircle(Result).Radius := ConvToFloatDef(St.Values['Radius'],
              100.0);
            TsgDXFCircle(Result).Point := MakeFPoint(ConvToFloatDef(St.Values['X'],
              0.0), ConvToFloatDef(St.Values['Y'], 0.0),
              ConvToFloatDef(St.Values['Z'], 0.0));
          end;
      end;
      Result.SetColor(fmCreateEntity.pnlColor.Color);
      Result.SetLWeight(fmCreateEntity.seWeight.Value);
    end;
  finally
    DecimalSeparator := Dc;
    fmCreateEntity.Free;
  end;
end;


procedure TfmCreateEntity.FormCreate(Sender: TObject);
begin
  cbEntity.ItemIndex := 0;
end;

procedure TfmCreateEntity.cbEntityChange(Sender: TObject);
begin
  mmCoordinates.Clear;
  case cbEntity.ItemIndex of
    0:
      begin
        mmCoordinates.Lines.Add('First point');
        mmCoordinates.Lines.Add('X1=0.0');
        mmCoordinates.Lines.Add('Y1=0.0');
        mmCoordinates.Lines.Add('Z1=0.0');
        mmCoordinates.Lines.Add('Second point');
        mmCoordinates.Lines.Add('X2=1000.0');
        mmCoordinates.Lines.Add('Y2=1000.0');
        mmCoordinates.Lines.Add('Z2=0.0');
      end;
    1:
      begin
        mmCoordinates.Lines.Add('Firs point');
        mmCoordinates.Lines.Add('X1=0.0');
        mmCoordinates.Lines.Add('Y1=0.0');
        mmCoordinates.Lines.Add('Z1=0.0');
        mmCoordinates.Lines.Add('Second point');
        mmCoordinates.Lines.Add('X2=500.0');
        mmCoordinates.Lines.Add('Y2=400.0');
        mmCoordinates.Lines.Add('Z2=0.0');
        mmCoordinates.Lines.Add('Third point');
        mmCoordinates.Lines.Add('X3=800.0');
        mmCoordinates.Lines.Add('Y3=1000.0');
        mmCoordinates.Lines.Add('Z3=0.0');
        mmCoordinates.Lines.Add('Fourth point');
        mmCoordinates.Lines.Add('X4=1500.0');
        mmCoordinates.Lines.Add('Y4=3000.0');
        mmCoordinates.Lines.Add('Z4=0.0');
        mmCoordinates.Lines.Add('');
      end;
    2:
      begin
        mmCoordinates.Lines.Add('Radius=100.0');
        mmCoordinates.Lines.Add('Center');
        mmCoordinates.Lines.Add('X=300.0');
        mmCoordinates.Lines.Add('Y=300.0');
        mmCoordinates.Lines.Add('Z=0.0');
      end;
  end;
end;


procedure TfmCreateEntity.bntColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    pnlColor.Color := ColorDialog1.Color;
end;

end.

