unit Unit1;
{$INCLUDE SGDXF.INC}

//{$DEFINE SG_USEDXFEXPORT}// only for DXFExport VCL

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, JPEG,
  ExtCtrls, StdCtrls, DXFImage, DXFConv, ComCtrls, Menus, Printers, MVFont,
  SGImage, ExtDlgs, Buttons, SGExport, sgOrbit3D, sgConsts,
  {$IFNDEF sgDXFONLY}
  DWG, HPGL2, CGM, SVG,
  {$ENDIF}
  {$IFDEF SG_USEDXFEXPORT}
  DXFExport,
  {$ENDIF}
  ShellAPI,
  {$IFNDEF VER100}
  fLayers,
  {$ENDIF}
  Spin, sgLines,
  ShlObj, ActiveX, IniFiles, SHX, Math, sgTools;

const
  sNotVectorial: string = 'Raster drawings can not be saved to DXF format';

type
  TSelectionMode = (smNone, smRectangle, smEllipse);

  TRectangleAround = record
    Box: TFRect;
    PaperSpace: Integer;
  end;

{$IFDEF SGDEL_4}
  TSnapMarker = class
  private
    FDrawAreaSize: Integer;
    FDXFImage: TsgDXFImage;
    FImageOnPaint: TNotifyEvent;
    FImageOnScaling: TNotifyEvent;
    FImageScale: Double;
    FPoint: TPoint;
    FRealPoint: TFPoint;
    FRepaint: Boolean;
    FRescaling: Boolean;
    FsgImage: TsgImage;
    FSnap: TObjectSnapMode;
    FSnapped: Boolean;
    procedure ClearPoint;
    procedure Draw(Erase: Boolean);
    procedure Erase;
    procedure Repaint(Sender: TObject);
    procedure Rescaling(Sender: TObject);
    procedure ResetsgImage;
    procedure SetDXFImage(ADXFImage: TsgDXFImage);
    procedure SetsgImage;
  public
    constructor Create(AsgImage: TsgImage);
    destructor Destroy; override;
    procedure ClearSnap;
    procedure Snap(APoint: TFPoint; ASnap: TObjectSnapMode);
  end;
{$ENDIF}

  TForm1 = class(TForm)
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    MIFile: TMenuItem;
    MIOpen: TMenuItem;
    MIClose: TMenuItem;
    N4: TMenuItem;
    MIExit: TMenuItem;
    Panel1: TPanel;
    Panel3: TPanel;
    MIView: TMenuItem;
    MiOEM: TMenuItem;
    PrintDialog1: TPrintDialog;
    MIPrint: TMenuItem;
    ScrollBox1: TScrollBox;
    MIScale: TMenuItem;
    MIAuto: TMenuItem;
    MIx2: TMenuItem;
    MIx4: TMenuItem;
    MIx8: TMenuItem;
    MIx16: TMenuItem;
    MIPrev: TMenuItem;
    N1: TMenuItem;
    N251: TMenuItem;
    N501: TMenuItem;
    sgPaintBox: TsgImage;
    MIx1: TMenuItem;
    OpenDialog1: TOpenPictureDialog;
    Panel4: TPanel;
    BtnOpen: TSpeedButton;
    BtnPlus: TSpeedButton;
    BtnMinus: TSpeedButton;
    BtnReal: TSpeedButton;
    BtnPrev: TSpeedButton;
    BtnPrint: TSpeedButton;
    N2: TMenuItem;
    MIAbout: TMenuItem;
    BtnSave: TSpeedButton;
    miSaveAs: TMenuItem;
    SavePictureDialog: TSavePictureDialog;
    ImageColors1: TMenuItem;
    Disabled1: TMenuItem;
    Black1: TMenuItem;
    Normal1: TMenuItem;
    SoftGoldHomePage1: TMenuItem;
    btnLayers: TSpeedButton;
    BtnPrint1: TSpeedButton;
    pnlCoords: TPanel;
    btnFitToScreen: TSpeedButton;
    btnIsWithoutBorder: TSpeedButton;
    btnDrawAllColor: TSpeedButton;
    btnBlackWhite: TSpeedButton;
    btnWhiteBackground: TSpeedButton;
    btnBlackBackground: TSpeedButton;
    btnShowLineWeight: TSpeedButton;
    btnHideLineWeight: TSpeedButton;
    btnSplittedArc: TSpeedButton;
    btnArcNormal: TSpeedButton;
    sb3DOrbit: TSpeedButton;
    BtnPrint2: TSpeedButton;
    PopupMenu1: TPopupMenu;
    Printer1: TMenuItem;
    Metafile1: TMenuItem;
    miSaveAsBigEMF: TMenuItem;
    SavePictureDialogEMF: TSavePictureDialog;
    pnlLayouts: TPanel;
    lblLayouts: TLabel;
    cbLayouts: TComboBox;
    lblNumPartsCircle: TLabel;
    speNumPartsCircle: TSpinEdit;
    lblNumPartsSpline: TLabel;
    speNumPartsSpline: TSpinEdit;
    sb3DAxes: TSpeedButton;
    Showpoint1: TMenuItem;
    Findtext1: TMenuItem;
    Reopenwithsameview1: TMenuItem;
    miFonts: TMenuItem;
    N3: TMenuItem;
    sbFonts: TSpeedButton;
    sbDrid: TSpeedButton;
    speGridCount: TSpinEdit;
    lblDridCount: TLabel;
    sbDrawingBox: TSpeedButton;
    ReopenwithSWisometricview1: TMenuItem;
    sbShowBorder: TSpeedButton;
    imgFrame: TImage;
    OpenBorder: TOpenPictureDialog;
    Snap1: TMenuItem;
    OSAllExecute: TMenuItem;
    procedure MIOpenClick(Sender: TObject);
    procedure MICloseClick(Sender: TObject);
    procedure MIExitClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure MiOEMClick(Sender: TObject);
    procedure MIPrintClick(Sender: TObject);
    procedure MIAutoClick(Sender: TObject);
    procedure MIx2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MIPrevClick(Sender: TObject);
    procedure sgPaintBoxScaling(Sender: TObject);
    procedure sgPaintBoxProgress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
      const Msg: String);
    procedure BtnPlusClick(Sender: TObject);
    procedure BtnMinusClick(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure MIHelpClick(Sender: TObject);
    procedure OpenDialog1Show(Sender: TObject);
    procedure OpenDialog1Close(Sender: TObject);
    procedure ScrollBox1Resize(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure Disabled1Click(Sender: TObject);
    procedure Black1Click(Sender: TObject);
    procedure Normal1Click(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure SoftGoldHomePage1Click(Sender: TObject);
    procedure MIAboutClick(Sender: TObject);
    procedure btnLayersClick(Sender: TObject);
    procedure sgPaintBoxPaint(Sender: TObject);
    procedure sgPaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BtnPrint1Click(Sender: TObject);
    procedure btnFitToScreenClick(Sender: TObject);
    procedure btnIsWithoutBorderClick(Sender: TObject);
    procedure btnShowLineWeightClick(Sender: TObject);
    procedure btnSplittedArcClick(Sender: TObject);
    procedure btnDrawAllColorClick(Sender: TObject);
    procedure btnWhiteBackgroundClick(Sender: TObject);
    procedure sb3DOrbitClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Printer1Click(Sender: TObject);
    procedure Metafile1Click(Sender: TObject);
    procedure BtnPrint2Click(Sender: TObject);
    procedure miSaveAsBigEMFClick(Sender: TObject);
    procedure cbLayoutsChange(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure speNumPartsCircleChange(Sender: TObject);
    procedure speNumPartsSplineChange(Sender: TObject);
    procedure sb3DAxesClick(Sender: TObject);
    procedure Showpoint1Click(Sender: TObject);
    procedure Findtext1Click(Sender: TObject);
    procedure Reopenwithsameview1Click(Sender: TObject);
    procedure miFontsClick(Sender: TObject);
    procedure speGridCountChange(Sender: TObject);
    procedure sbDrawingBoxClick(Sender: TObject);
    procedure ReopenwithSWisometricview1Click(Sender: TObject);
    procedure sbShowBorderClick(Sender: TObject);
    procedure OSAllExecuteClick(Sender: TObject);
    procedure SaveToDXF(AFileName: string);
  private
    Orbit3D: TsgOrbit3D;
    FSearchingText: string;
    FTextPoint: TFPoint;
    FTextBox: TFRect;
    FCADParams: TsgCADIterate;
    FSearchResult: Boolean;
    FFindFlag: Boolean;
    FSelectionMode: TSelectionMode;
    FSearchModeIsAll: Boolean;
    FSelectedEntities: TList;
    FFileName: string;
    FOptions: TIniFile;
    FStoredNullWidth: Integer;
{$IFDEF SGDEL_4}
    FSnapMarkers: TSnapMarker;
    FObjectSnap: TsgObjectSnap;
    FSnappedEntity: TsgDXFEntity;
    FSnapMode: TObjectSnapMode;
    procedure CreateSnapObject;
    procedure SetSnapMode(Value: TObjectSnapMode);
{$ENDIF}
    procedure Enable3DOrbit(AIsEnabled: Boolean);
    procedure Enable3DAxes(AIsEnabled: Boolean);
    function GetMouseCoord(X, Y: Integer): TFPoint;
    procedure LoadStructure;
    procedure Time;
    procedure EnableScales;
    procedure Open(const FileName: String);
    procedure RestoreNullWidth(AGraphic: TGraphic);
    procedure SetBtnEnable(AEnable: Boolean);
    procedure SetImgOpt;
    procedure SetNullWidth(AGraphic: TGraphic; AWidth: Integer);
    procedure ViewLayouts;
  protected
    procedure ActualGraphic(var vResult: TGraphic);
    function AddRectToConv(ABox: TFRect): TsgDXFEntity;
    procedure SelectEntities;
    procedure LoadOptions;
    procedure BreakLoading(Sender: TObject);
{$IFDEF SGDEL_4}
    property SnapMode: TObjectSnapMode read FSnapMode write SetSnapMode;
{$ENDIF}
  public
    function FindText(const S: String; const ASelection: TSelectionMode; const ASearch: Boolean): Boolean;
    procedure ReadCADEntities(Entity: TsgDXFEntity);
  end;

const
  iSnapMarkerSize = 8;


var
  Form1: TForm1;
  Img: TsgDXFImage;
  Start: Integer;
  FIntPoints: TList;
  Cntr: Integer = 1;

implementation

uses
  Unit2, Unit3,
  fFonts, fPaths;

{$R *.DFM}

function GetRealPointUsingsgImagePoint(AsgImage: TsgImage; X, Y: Integer): TFPoint;
var
  vRect: TRect;
begin
    if not (AsgImage.Picture.Graphic is TsgDXFImage) then
    begin
      Result := MakeFPoint(0, 0, 0);
      Exit;
    end;
    vRect := AsgImage.PictureRect;
    if TsgDXFImage(AsgImage.Picture.Graphic).Converter.IsCrossoverMatrix then
      if ((vRect.Right - vRect.Left) <= AsgImage.Width) or ((vRect.Bottom - vRect.Top) <= AsgImage.Height) then
        Result := TsgDXFImage(AsgImage.Picture.Graphic).GetCADCoords(X / (vRect.Right - vRect.Left),
                                                                    (AsgImage.Height - Y) / (vRect.Bottom - vRect.Top))
      else
        Result := TsgDXFImage(AsgImage.Picture.Graphic).GetCADCoords((-(vRect.Left  - AsgImage.Left) + X) / (vRect.Right - vRect.Left),
                                                                    1 - (Y - (vRect.Top - AsgImage.Top)) / (vRect.Bottom - vRect.Top))
    else
      if ((vRect.Right - vRect.Left) <= AsgImage.Width) or ((vRect.Bottom - vRect.Top) <= AsgImage.Height) then
        Result := TsgDXFImage(AsgImage.Picture.Graphic).GetCADCoords(X / (vRect.Right - vRect.Left),
                                                                    Y / (vRect.Bottom - vRect.Top))
      else
        Result := TsgDXFImage(AsgImage.Picture.Graphic).GetCADCoords((-(vRect.Left  - AsgImage.Left) + X) / (vRect.Right - vRect.Left),
                                                                    (Y - (vRect.Top - AsgImage.Top)) / (vRect.Bottom - vRect.Top));
end;

function CreateLines(D: integer; AWidth, AHeight: integer): boolean;
var
  I: integer;
  dx, dy: integer;
begin
  if FIntPoints = nil then
    FIntPoints := TList.Create
  else
    FIntPoints.Clear;
  I := 0;
  if D <= 0 then
    D := 1;
  dx := D;
  dy := D;
  while (I*dx <= AWidth) do
  begin
    FIntPoints.Add(pointer(I * dx));
    FIntPoints.Add(pointer(0));
    FIntPoints.Add(pointer(I * dx));
    FIntPoints.Add(pointer(AHeight));
    inc(I);
  end;
  I := 0;
  while (I*dy <= AHeight) do
  begin
    FIntPoints.Add(pointer(0));
    FIntPoints.Add(pointer(I * dy));
    FIntPoints.Add(pointer(AWidth));
    FIntPoints.Add(pointer(I * dy));
    inc(I);
  end;
  Result := True;
  if FIntPoints.Count < 2 then
    Result := False;
end;

procedure DrawPolyPolyLine(DC: HDC; IntPoints: TList);
var
  I, N, C: Integer;
  P: Pointer;
begin
  N := IntPoints.Count shr 2;
  if N = 0 then
    Exit;
  C := IntPoints.Count;
  for I := 0 to N - 1 do
    IntPoints.Add(Pointer(2));
  P := IntPoints.List;
  Inc(PInteger(P), C);
  PolyPolyline(DC, IntPoints.List^, P^, N);
end;

procedure TForm1.LoadOptions;
var
  vSet: string;
begin
   if not Assigned(FOptions) then
   begin
    vSet := ExtractFilePath(Application.ExeName) + sSettings;
    FOptions := TIniFile.Create(vSet);
   end;
   bUseSHXFonts := FOptions.ReadBool(sGeneral, sUseSHX, bUseSHXFonts);
   sSHXSearchPaths := FOptions.ReadString(sGeneral, sSHXPaths, sSHXSearchPaths);
   sDefaultSHXPath := FOptions.ReadString(sGeneral, sSHXPath, sDefaultSHXPath);
   sDefaultSHXFont := FOptions.ReadString(sGeneral, sSHXFont, sDefaultSHXFont);
end;

function TForm1.AddRectToConv(ABox: TFRect): TsgDXFEntity;
var
  Vertex: TsgDXFVertex;
begin
  Result := TsgDXFPolyline.Create;
  Vertex := TsgDXFVertex.Create;
  Vertex.Point := ABox.TopLeft;
  Result.AddEntity(Vertex);
  Vertex := TsgDXFVertex.Create;
  Vertex.Point := MakeFPoint(ABox.BottomRight.X, ABox.TopLeft.Y, ABox.TopLeft.Z);
  Result.AddEntity(Vertex);
  Vertex := TsgDXFVertex.Create;
  Vertex.Point := ABox.BottomRight;
  Result.AddEntity(Vertex);
  Vertex := TsgDXFVertex.Create;
  Vertex.Point := MakeFPoint(ABox.TopLeft.X, ABox.BottomRight.Y, ABox.BottomRight.Z);
  Result.AddEntity(Vertex);
  Result.SetColor(clRed);
  Result.SetLWeight(1);
  TsgDXFPolyline(Result).Closed := True;
end;

procedure TForm1.ReadCADEntities(Entity: TsgDXFEntity);
var
  vScale: Extended;
  S1, S2: String;
  mmToPixelX: Double;
  vRectAround: ^TRectangleAround;
  P: TFPoint;
  CurAttrib: TsgDXFAttrib;
  vBox: TFRect;
  vAttribFlag: Boolean;
begin
  if FFindFlag then
    Exit;
  if Entity is TsgDXFMText then
  begin
    FTextPoint := TsgDXFMText(Entity).Point;
  end;
  if Entity is TsgDXFText then
  begin
    S1 := AnsiUpperCase(FSearchingText);
    S2 := AnsiUpperCase(TsgDXFText(Entity).Text);
    vAttribFlag := False;
    if FCADParams.Insert <> nil then
    begin
      P := PtXMat(TsgDXFText(Entity).StartPoint, FCADParams.Matrix);
      CurAttrib := FCADParams.Insert.Attrib(S2, P);
      if CurAttrib <> nil then
      begin
        S2 := CurAttrib.Text;
        vBox := CurAttrib.Box;
        vAttribFlag := True;
      end;
    end;
    if AnsiPos(S1, S2) > 0 then
    begin
      FSearchResult := True;
      FTextPoint := PtXMat(TsgDXFText(Entity).StartPoint, FCADParams.Matrix);
      mmToPixelX := GetDeviceCaps(GetDc(0),HORZSIZE) / GetDeviceCaps(GetDc(0),HORZRES);
      FTextBox.TopLeft := PtXMat(TsgDXFText(Entity).Box.TopLeft, FCADParams.Matrix);
      FTextBox.BottomRight := PtXMat(TsgDXFText(Entity).Box.BottomRight, FCADParams.Matrix);
      vScale := mmToPixelX * sgPaintBox.Parent.Height / Abs(FTextBox.TopLeft.Y - FTextBox.BottomRight.Y) * 5;
      sgPaintBox.ScaleMMWidth := Img.AbsWidth;
      Form1.sgPaintBox.Align := alNone;
      Form1.sgPaintBox.ShowPoint(FTextPoint, vScale, Img.Extents);
      if not(FSearchModeIsAll) then
        FFindFlag := True;
      if FSelectionMode = smRectangle then
      begin
        New(vRectAround);
        if not vAttribFlag then
        begin
          vRectAround^.Box.TopLeft := PtXMat(Entity.Box.TopLeft, FCADParams.Matrix);
          vRectAround^.Box.BottomRight := PtXMat(Entity.Box.BottomRight, FCADParams.Matrix);
        end
        else
          vRectAround^.Box := vBox;
        vRectAround.PaperSpace := Ord(Img.Layouts[0] <> Img.CurrentLayout);
        FSelectedEntities.Add(vRectAround);
      end;
    end;
  end;
end;

procedure TForm1.SelectEntities;
var
  I: Integer;
  Ent: TsgDXFEntity;
  Im: TsgDXFImage;
begin
  for I := 0 to FSelectedEntities.Count - 1 do
  begin
    Ent := AddRectToConv(TRectangleAround(FSelectedEntities[I]^).Box);
    if Ent <> nil then
    begin
      Im := TsgDXFImage(sgPaintBox.Picture.Graphic);
      Im.Converter.Sections[csEntities].AddEntity(Ent);
      if Assigned(Im.Converter.OnCreate) then
        Im.Converter.OnCreate(Ent);
      Im.Converter.Loads(Ent);
      Ent.PaperSpace := TRectangleAround(FSelectedEntities[I]^).PaperSpace;
      sgPaintBox.Invalidate;
    end;
  end;
end;

function TForm1.FindText(const S: String; const ASelection: TSelectionMode; const ASearch: Boolean): Boolean;
var
  I: Integer;
begin
  FSearchingText := S;
  FSelectionMode := ASelection;
  FSearchModeIsAll := ASearch;
  FSearchResult := False;
  FCADParams.Matrix := IdentityMat;
  Img.Converter.AutoInsert := True; // to get all the elements inside of inserts
  FFindFlag := False;
  FSelectedEntities := TList.Create;
  try
    Img.Converter.Iterate(ReadCADEntities, FCADParams);
    SelectEntities;
  finally
    for I := 0 to FSelectedEntities.Count - 1 do
      Dispose(FSelectedEntities[I]);
    FSelectedEntities.Free;
  end;
  Result := FSearchResult;
end;

procedure TForm1.Time;
var T: Integer;
begin
  T := (GetCurrentTime - Start) div 1000;
  Panel3.Caption := Format('%.2d:%.2d', [T div 60, T mod 60]);
  Panel3.Update;
end;

procedure TForm1.LoadStructure;

  procedure Add(Parent: TTreeNode; E: TsgDXFEntity);
  var
    I: Integer;
  begin
    Parent := TreeView1.Items.AddChildObject(Parent, E.EntName, E);
    Application.ProcessMessages;
    with ProgressBar1 do Position := Position + 1;
    for I:=0 to E.Count-1 do Add(Parent, E[I]);
  end;

var
  I: Integer;
  S_LStructure: string;
begin
  if Img = nil then Exit;
  ProgressBar1.Position := 0;
  ProgressBar1.Max := Img.Converter.Count;
  Panel1.Caption := S_LStructure;
  Panel1.Update;
  TreeView1.Items.BeginUpdate;
  try
    for I:=0 to Img.Converter.Main.Count-1
    do Add(nil, Img.Converter.Main[I]);
  finally
    ProgressBar1.Position := 0;
    TreeView1.Items.EndUpdate;
  end;
end;

procedure TForm1.EnableScales;
var I: Integer;
begin
  for I := 3 to MIScale.Count-1 do
    MIScale.Items[I].Enabled := not sgPaintBox.Empty;
  MIPrint.Enabled := MIx2.Enabled;
  BtnSave.Enabled := MIx2.Enabled;
  BtnPrint.Enabled := MIx2.Enabled;
  BtnPrint1.Enabled := MIx2.Enabled;
  BtnPrint2.Enabled := MIx2.Enabled;
  BtnPlus.Enabled := MIx2.Enabled;
  BtnMinus.Enabled := MIx2.Enabled;
  BtnReal.Enabled := MIx2.Enabled;
  btnFitToScreen.Enabled := MIx2.Enabled;
  miSaveAsBigEMF.Enabled := MIx2.Enabled;
  Showpoint1.Enabled := MIx2.Enabled;
  FindText1.Enabled := MIx2.Enabled;
end;

procedure TForm1.Open(const FileName: String);
var
  vBreakForm: TForm;

  procedure MakeBreakForm;
  var
    vB: TButton;
  begin
    vBreakForm.BorderStyle := bsDialog;
    vBreakForm.Width := 151;
    vBreakForm.Height := 76;
    vBreakForm.Caption := 'Loading...';
    vBreakForm.Left := Left + Width div 2 - vBreakForm.Width div 2;
    vBreakForm.Top := Top + Height div 2 - vBreakForm.Height div 2;
    vB := TButton.Create(vBreakForm);
    vB.Parent := vBreakForm;
    vB.Left := 8;
    vB.Top := 8;
    vB.Width := 125;
    vB.Height := 23;
    vB.Caption := 'Break loading';
    vB.OnClick := BreakLoading;
    vBreakForm.Show;
  end;

begin
  FFileName := FileName;
  TreeView1.Items.Clear;
  Orbit3D.Visible := False;
  Start := GetCurrentTime;
  Screen.Cursor := crAppStart;
  sgPaintBox.IsBigScale := False;
  vBreakForm := TForm.Create(Self);
  MakeBreakForm;
  try
    sgPaintBox.LoadFromFile(FileName);
    if sgPaintBox.Picture.Graphic is TBitmap then
      sgPaintBox.Picture.Bitmap.HandleType := bmDDB;
    MIClose.Enabled := True;
    btnLayers.Enabled := True;
    Panel1.Caption := UpperCase(ExtractFileName(FileName));
    EnableScales;
    HelpContext := 3;
    MIAutoClick(nil);
    sb3DOrbit.Enabled := False;
    sb3DAxes.Down := False;
    sb3DAxes.Enabled := False;
    pnlLayouts.Visible := False;
    if not (sgPaintBox.Picture.Graphic is TsgDXFImage) then Exit;
    Img := TsgDXFImage(sgPaintBox.Picture.Graphic);
    sgPaintBox.IsBigScale := True; // turn on accurate CAD scaling
    SetImgOpt;
    TabSheet2.TabVisible := True;
    Panel1.Caption := UpperCase(ExtractFileName(FileName));
    MIPrint.Enabled := True;
    MiOEM.Enabled := True;
    MiOEM.Checked := not Img.Converter.OEM;
    miFonts.Enabled := True;
    MiOEMClick(nil);
    sbDrawingBox.Enabled := True;
    ViewLayouts;
    speNumPartsCircle.Value := Img.Converter.NumberOfPartsInCircle;
    speNumPartsSpline.Value := Img.Converter.NumberOfPartsInSpline;
    sgPaintBox.ScaleMMWidth := Img.AbsWidth;
{$IFDEF SGDEL_4}
    if sgPaintBox.Picture.Graphic is TsgDXFImage then
    begin
      FObjectSnap.SetsgDXFImage(Img);
      if Assigned(FSnapMarkers) then
        FSnapMarkers.SetDXFImage(Img);
    end;
{$ENDIF}
  finally
    vBreakForm.Free;
    ProgressBar1.Position := 0;
    Screen.Cursor := crDefault;
    miSaveAs.Enabled := sgPaintBox.Picture.Graphic is TsgDXFImage;
    SetBtnEnable(sgPaintBox.Picture.Graphic is TsgDXFImage);
  end;
end;

procedure TForm1.MIOpenClick(Sender: TObject);
begin
  OpenDialog1.FileName := '';
  {$IFNDEF sgDXFONLY}
  DWGPreview := True;
  {$ENDIF}
  try
    if not OpenDialog1.Execute then Exit;
  finally
  {$IFNDEF sgDXFONLY}
    DWGPreview := False;
  {$ENDIF}
  end;
  MICloseClick(nil);
  Open(OpenDialog1.FileName);
end;

procedure TForm1.MICloseClick(Sender: TObject);
begin
  ListBox1.Clear;
  TreeView1.Items.Clear;
  sgPaintBox.Picture.Graphic := nil;
  Img := nil;
  Panel1.Caption := '';
  Panel3.Caption := '';
  MIClose.Enabled := False;
  MIPrint.Enabled := False;
  MiOEM.Enabled := False;
  BtnSave.Enabled := False;
  PageControl1.ActivePage := TabSheet1;
  TabSheet2.TabVisible := False;
  EnableScales;
  sgPaintBox.Align := alNone;
  sgPaintBox.SetBounds(0,0,0,0);
  ProgressBar1.Max := 100;
  HelpContext := 1;
  SetBtnEnable(False);
end;

procedure TForm1.MIExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  E: TsgDXFEntity;
  S: String;
begin
  if not Node.Selected then Exit;
  E := TsgDXFEntity(Node.Data);
  if (E=nil) or (E.SrcStart = nil) or (E.SrcEnd = nil)
  then ListBox1.Clear
  else begin
    SetString(S, E.SrcStart, E.SrcEnd - E.SrcStart);
    ListBox1.Items.Text := S;
  end;
end;

procedure TForm1.MiOEMClick(Sender: TObject);
const CS: array[Boolean] of TFontCharset = (DEFAULT_CHARSET, OEM_CHARSET);
begin
  with MiOEM do Checked := not Checked;
  if Img=nil then Exit;
  Img.Charset := CS[MiOEM.Checked];
  ListBox1.Font.Charset := Img.Charset;
end;

procedure TForm1.SetNullWidth(AGraphic: TGraphic; AWidth: Integer);
begin
  if AGraphic is TsgDXFImage then
  begin
    FStoredNullWidth := TsgDXFImage(AGraphic).NullWidth;
    TsgDXFImage(AGraphic).NullWidth := AWidth;
  end;
end;

procedure TForm1.RestoreNullWidth(AGraphic: TGraphic);
begin
  if AGraphic is TsgDXFImage then
    TsgDXFImage(AGraphic).NullWidth := FStoredNullWidth;
end;

procedure TForm1.MIPrintClick(Sender: TObject);
const PO: array[Boolean] of TPrinterOrientation = (poPortrait,poLandscape);
var
  W,H: Double;
  PW,PH: Integer;
begin
  with sgPaintBox.Picture do
    Printer.Orientation := PO[Width > Height];
  if PrintDialog1.Execute then
  begin
    SetNullWidth(sgPaintBox.Picture.Graphic, 3);
    with Printer, sgPaintBox.Picture do
    begin
      W := PageWidth / Width;
      H := PageHeight / Height;
      if W > H then W := H;
      PW := Round(W * Width);
      PH := Round(W * Height);
      BeginDoc;
      Canvas.StretchDraw(Bounds((PageWidth-PW) div 2, (PageHeight-PH) div 2, PW, PH), Graphic);
      EndDoc;
    end;
    RestoreNullWidth(sgPaintBox.Picture.Graphic);
    sgPaintBox.Repaint;
  end;
end;

procedure TForm1.Printer1Click(Sender: TObject);
const PO: array[Boolean] of TPrinterOrientation = (poPortrait,poLandscape);
var           
  W,H: Double;
  PW,PH: Integer;
  vGr: TGraphic;
begin
  with sgPaintBox.Picture do
    Printer.Orientation := PO[Width > Height];
  if PrintDialog1.Execute then
  begin
    SetNullWidth(sgPaintBox.Picture.Graphic, 3);
    with Printer do
    begin
      vGr := TMetafile.Create;
      try
        ActualGraphic(vGr);
        W := PageWidth / vGr.Width;
        H := PageHeight / vGr.Height;
        if W > H then W := H;
        PW := Round(W * vGr.Width);
        PH := Round(W * vGr.Height);
        BeginDoc;
        Canvas.StretchDraw(Bounds((PageWidth-PW) div 2, (PageHeight-PH) div 2, PW, PH), vGr);
        EndDoc;
      finally
        vGr.Free;
      end;
    end;
    RestoreNullWidth(sgPaintBox.Picture.Graphic);
    sgPaintBox.Repaint;
  end;
end;

procedure TForm1.Metafile1Click(Sender: TObject);
var
  vGr: TGraphic;
begin
  SavePictureDialog.FilterIndex := 3;
  if sgPaintBox.Empty or not SavePictureDialog.Execute then Exit;
  vGr := TMetafile.Create;
  try
    ActualGraphic(vGr);
    if ExtractFileExt(SavePictureDialog.FileName) = '' then
      vGr.SaveToFile(SavePictureDialog.FileName+'.emf')
    else
      vGr.SaveToFile(SavePictureDialog.FileName);
  finally
    vGr.Free;
  end;
end;

procedure TForm1.BreakLoading(Sender: TObject);
begin
  if Loading <> nil then Loading.StopLoading;
end;

procedure TForm1.ActualGraphic(var vResult: TGraphic);
const
  KfWinNT = 1209;
  MPerInch = 25.1;

var
  vMC: TMetafileCanvas;
  vRect: TRect;
  vRGN: HRGN;
  OSVersionInfo: TOSVersionInfo;
  DC: HDC;
  mmToPixelX, mmToPixelY: Double;
  imgRectangle: TRect;
begin
  imgRectangle := ScrollBox1.ClientRect;

  DC := GetDC(0);
  try
    mmToPixelX := GetDeviceCaps(DC,HORZSIZE) /
      GetDeviceCaps(DC,HORZRES);
    mmToPixelY := GetDeviceCaps(DC,VERTSIZE) /
      GetDeviceCaps(DC,VERTRES);
  finally
    ReleaseDC(Handle, DC);
  end;

  vRect := sgPaintBox.PictureRect;
  vRect.Left := vRect.Left - imgRectangle.Left;
  vRect.Top := vRect.Top - imgRectangle.Top;
  vRect.Right := vRect.Right - imgRectangle.Left;
  vRect.Bottom := vRect.Bottom - imgRectangle.Top;

  OSVersionInfo.dwOSVersionInfoSize := sizeof(TOSVersionInfo);
  GetVersionEx(OSVersionInfo);
  if OSVersionInfo.dwPlatformId = VER_PLATFORM_WIN32_NT then
  begin
    TMetafile(vResult).MMWidth := Round((imgRectangle.Right - imgRectangle.Left) * 1000 * mmToPixelX);
    TMetafile(vResult).MMHeight := Round((imgRectangle.Bottom - imgRectangle.Top) * 1000 * mmToPixelY);
    vRect.Left := vRect.Left * 10;
    vRect.Top := vRect.Top * 10;
    vRect.Right := vRect.Right * 10;
    vRect.Bottom := vRect.Bottom * 10;
  end
  else // win98
  begin
    TMetafile(vResult).MMWidth := Round((imgRectangle.Right - imgRectangle.Left) * 500 * mmToPixelX);
      TMetafile(vResult).MMHeight := Round((imgRectangle.Bottom - imgRectangle.Top) * 500 * mmToPixelY);
      vRect.Left := vRect.Left * 5;
      vRect.Top := vRect.Top * 5;
      vRect.Right := vRect.Right * 5;
      vRect.Bottom := vRect.Bottom * 5;
    end;
    vMC := TMetafileCanvas.Create(TMetafile(vResult), 0);
    try
      if OSVersionInfo.dwPlatformId = VER_PLATFORM_WIN32_NT then
        vRGN := CreateRectRgn(0, 0, (imgRectangle.Right - imgRectangle.Left) * 10, (imgRectangle.Bottom - imgRectangle.Top) * 10)
      else
        vRGN := CreateRectRgn(0, 0, (imgRectangle.Right - imgRectangle.Left) * 5, (imgRectangle.Bottom - imgRectangle.Top) * 5);

      SelectClipRgn(vMC.Handle, vRGN);
      vMC.StretchDraw(vRect, sgPaintBox.Picture.Graphic);
      DeleteObject(vRGN);
    finally
      vMC.Free;
      if Img <> nil then
        Img.IsShowBackground := True;
    end;
end;

procedure TForm1.MIAutoClick(Sender: TObject);
begin
  sgPaintBoxScaling(nil);
  sgPaintBox.Align := alClient;
  MIAuto.Enabled := False;
end;

procedure TForm1.MIx2Click(Sender: TObject);
begin
  if Sender=BtnReal then Sender := MIx1;
  sgPaintBox.ChangeScale(True, TComponent(Sender).Tag / 100, sgPaintBox.Center);
  TMenuItem(Sender).Checked := True;
  BtnReal.Enabled := not MIx1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFNDEF VER100}
  Self.OnMouseWheelDown := FormMouseWheelDown;
  Self.OnMouseWheelUp := FormMouseWheelUp;
  {$ENDIF}
  LoadOptions;
  OpenDialog1.Filter := GraphicFilter(TGraphic);
  if ParamCount > 0 then begin
    Open(ParamStr(1));
    OpenDialog1.FileName := ParamStr(1);
  end;
  Orbit3D := TsgOrbit3D.Create(Self);
  Orbit3D.Drawing := sgPaintBox;
  Orbit3D.Parent := ScrollBox1;
  Orbit3D.Visible := False;
  pnlLayouts.Visible := False;
  sbDrawingBox.Enabled := False;

{$IFDEF SGDEL_4}
  FObjectSnap := TsgObjectSnap.Create;
  FSnappedEntity := nil;
{$ENDIF}
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure Scroll(Both: Boolean; Msg,Code1,Code2: Word);
  begin
    if ssCtrl in Shift then Code1 := Code2;
    SendMessage(ScrollBox1.Handle, Msg, Code1, 0);
    if Both and (ssCtrl in Shift)
    then SendMessage(ScrollBox1.Handle, WM_VSCROLL, Code1, 0);
  end;
begin
  sgPaintBox.Cancel;
  if Key = VK_ESCAPE then Close;
  if sgPaintBox.Empty or (PageControl1.ActivePage <> TabSheet1) or (Shift-[ssCtrl] <> [])
  then Exit;
  case Key of
    VK_ADD:		BtnPlusClick(nil);
    VK_SUBTRACT:	BtnMinusClick(nil);
    VK_MULTIPLY:	MIx2Click(BtnReal);
    VK_UP:		Scroll(False, WM_VSCROLL, SB_LINELEFT, SB_PAGELEFT);
    VK_DOWN:		Scroll(False, WM_VSCROLL, SB_LINERIGHT, SB_PAGERIGHT);
    VK_PRIOR:		Scroll(False, WM_VSCROLL, SB_PAGELEFT, SB_TOP);
    VK_NEXT:		Scroll(False, WM_VSCROLL, SB_PAGERIGHT, SB_BOTTOM);
    VK_LEFT:		Scroll(False, WM_HSCROLL, SB_LINELEFT, SB_PAGELEFT);
    VK_RIGHT:		Scroll(False, WM_HSCROLL, SB_LINERIGHT, SB_PAGERIGHT);
    VK_HOME:		Scroll(True, WM_HSCROLL, SB_TOP, SB_TOP);
    VK_END:		Scroll(True, WM_HSCROLL, SB_BOTTOM, SB_BOTTOM);
  end;
end;

procedure TForm1.MIPrevClick(Sender: TObject);
begin
  sgPaintBox.PrevScale;
end;

procedure TForm1.sgPaintBoxScaling(Sender: TObject);
begin
  sgPaintBox.Align := alNone;
  MIx2.Checked := True;
  MIx2.Checked := False;
  MIAuto.Enabled := True;
  BtnReal.Enabled := True;
  MIPrev.Enabled := sgPaintBox.HasPrevScale;
  BtnPrev.Enabled := MIPrev.Enabled;
end;

procedure TForm1.sgPaintBoxProgress(Sender: TObject; Stage: TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: String);
begin
  if Stage=psStarting then begin
    Panel1.Caption := Msg;
    Panel1.Update;
  end;
  ProgressBar1.Position := PercentDone;
  Time;
  if Stage=psEnding then begin
    ProgressBar1.Position := 0;
    Panel1.Caption := UpperCase(ExtractFileName(OpenDialog1.FileName))
  end;
end;

procedure TForm1.BtnPlusClick(Sender: TObject);
begin
  sgPaintBox.ChangeScale(False, 2, sgPaintBox.Center);
end;

procedure TForm1.BtnMinusClick(Sender: TObject);
begin
  sgPaintBox.ChangeScale(False, 0.5, sgPaintBox.Center);
end;

procedure TForm1.PageControl1Changing(Sender: TObject; var AllowChange: Boolean);
begin
  AllowChange := Img <> nil;
  FocusControl(nil);
end;

procedure TForm1.MIHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS,0);
end;

procedure TForm1.OpenDialog1Show(Sender: TObject);
begin
  MinDXFSize := 140;
end;

procedure TForm1.OpenDialog1Close(Sender: TObject);
begin
  MinDXFSize := 0;
end;

procedure TForm1.ScrollBox1Resize(Sender: TObject);
begin
  with sgPaintBox do
  if not Empty then SetBounds(Left,Top,Width,Height);
end;

procedure TForm1.BtnSaveClick(Sender: TObject);
var
  E: TsgExport;
  vMC: TMetafileCanvas;
  vM: TMetafile;
  vFileName: string;
begin
  if sgPaintBox.Empty or not SavePictureDialog.Execute then Exit;
  vFileName := SavePictureDialog.FileName;
  case SavePictureDialog.FilterIndex of
    1:
      if AnsiLowerCase(ExtractFileExt(vFileName)) <> '.bmp' then
        vFileName := vFileName + '.bmp';
    2:
      if (AnsiLowerCase(ExtractFileExt(vFileName)) <> '.jpg')
        or (AnsiLowerCase(ExtractFileExt(vFileName)) <> '.jpeg') then
        vFileName := vFileName + '.jpg';
    3:
      if (AnsiLowerCase(ExtractFileExt(vFileName)) <> '.emf') then
        vFileName := vFileName + '.emf';
    4:
      begin
        vM := TMetafile.Create;
        try
          vM.Width := sgPaintBox.Width;
          vM.Height := sgPaintBox.Height;
          vMC := TMetafileCanvas.Create(vM, 0);
          try
            vMC.StretchDraw(sgPaintBox.ClientRect, sgPaintBox.Picture.Graphic);
          finally
            vMC.Free;
          end;
          if AnsiLowerCase(ExtractFileExt(vFileName)) <> '.wmf' then
            vFileName := vFileName + '.wmf';
          vM.SaveToFile(vFileName);
          Exit;
        finally
          vM.Free;
        end;
      end;
    5:
      begin
        if AnsiLowerCase(ExtractFileExt(vFileName)) <> '.dxf' then
          vFileName := vFileName + '.dxf';
        SaveToDXF(vFileName);
        Exit;
      end;
  end;
  E := TsgExport.Create;
  try
    E.ExportTo(sgPaintBox.Picture.Graphic,
               vFileName,
               TsgExportFormat(SavePictureDialog.FilterIndex-1),
               sgPaintBox.Width,
               sgPaintBox.Height);
  finally
    E.Free;
  end;
end;

procedure TForm1.Disabled1Click(Sender: TObject);
begin
  if sgPaintBox.Empty or not
    (sgPaintBox.Picture.Graphic is TsgDXFImage) then
    Exit;
  (sgPaintBox.Picture.Graphic as TsgDXFImage).DrawMode := dmGray;
end;

procedure TForm1.Black1Click(Sender: TObject);
begin
  if sgPaintBox.Empty or not
    (sgPaintBox.Picture.Graphic is TsgDXFImage) then
    Exit;
  (sgPaintBox.Picture.Graphic as TsgDXFImage).DrawMode := dmBlack;
end;

procedure TForm1.Normal1Click(Sender: TObject);
begin
  if sgPaintBox.Empty or not
    (sgPaintBox.Picture.Graphic is TsgDXFImage) then
    Exit;
  (sgPaintBox.Picture.Graphic as TsgDXFImage).DrawMode := dmNormal;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if sgPaintBox.Empty or (PageControl1.ActivePage <> TabSheet1) then Exit;
  MousePos := ScrollBox1.ScreenToClient(MousePos);
  sgPaintBox.ChangeScale(False, 0.8, MousePos);
  Handled := True;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if sgPaintBox.Empty or (PageControl1.ActivePage <> TabSheet1) then Exit;
  MousePos := ScrollBox1.ScreenToClient(MousePos);
  sgPaintBox.ChangeScale(False, 1.2, MousePos);
  Handled := True;
end;

procedure TForm1.SoftGoldHomePage1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'www.cadsofttools.com', '', '', SW_SHOW);
end;


procedure TForm1.MIAboutClick(Sender: TObject);
begin
 ShowMessage('DWG/DXF VCLs demo version '+ #13#10 +
             'Please contact www.cadsofttools.com to order a full version');
end;

procedure TForm1.btnLayersClick(Sender: TObject);
begin
  if Img = nil then Exit;
  {$IFNDEF VER100}
  LayersDialogExecute(Img, sgPaintBox);
  {$ENDIF}
end;

procedure TForm1.sgPaintBoxPaint(Sender: TObject);
var
  vLeftTop, vRightBottom: TPoint;
  vExt: TFRect;
  vRectLeft, vRectTop: Integer;
  vBMPFrame: TBitmap;
  vImgRect: TRect;
begin
  {sgPaintBox.Canvas.Font.Size := 14;
  sgPaintBox.Canvas.Font.Color := clBlack;
  sgPaintBox.Canvas.Font.Name := 'Arial';
  sgPaintBox.Canvas.TextOut(20, 20, 'Custom drawing on Graphic Viewer allowed');}
  if Orbit3D.Visible then
    Orbit3D.Paint;

  if (Assigned(Img)) and (not Img.Empty) and (FSelectionMode = smEllipse) then
  begin
    vExt := Img.Extents;
    if sgPaintBox.UsePictureRect then
    begin
      vRectLeft := sgPaintBox.PictureRect.Left - sgPaintBox.Left;
      vRectTop := sgPaintBox.PictureRect.Top - sgPaintBox.Top;
      vLeftTop.X := Round((sgPaintBox.PictureRect.Right - sgPaintBox.PictureRect.Left) * (FTextBox.Left - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vLeftTop.Y := Round((sgPaintBox.PictureRect.Bottom - sgPaintBox.PictureRect.Top) * (1 - (FTextBox.Top - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
      vRightBottom.X := Round((sgPaintBox.PictureRect.Right - sgPaintBox.PictureRect.Left) *  (FTextBox.Right - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vRightBottom.Y := Round((sgPaintBox.PictureRect.Bottom - sgPaintBox.PictureRect.Top) * (1 - (FTextBox.Bottom - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
    end
    else
    begin
      vRectLeft := 0;
      vRectTop := 0;
      vLeftTop.X := Round(sgPaintBox.Width * (FTextBox.Left - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vLeftTop.Y := Round(sgPaintBox.Height * (1 - (FTextBox.Top - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
      vRightBottom.X := Round(sgPaintBox.Width *  (FTextBox.Right - vExt.Left) / (vExt.Right - vExt.Left)) + vRectLeft;
      vRightBottom.Y := Round(sgPaintBox.Height * (1 - (FTextBox.Bottom - vExt.Bottom) / (vExt.Top - vExt.Bottom))) + vRectTop;
    end;
    sgPaintBox.Canvas.Pen.Color := clRed;
    sgPaintBox.Canvas.Brush.Style := bsClear;
    sgPaintBox.Canvas.Ellipse(vLeftTop.X - 10, vLeftTop.Y - 10, vRightBottom.X + 10, vRightBottom.Y + 10);
  end;

  if sbDrid.Down then
  begin
    if (Assigned(Img)) and (not Img.Empty) then
    begin
      vExt := Img.Extents;
      if CreateLines(Round(Img.AbsWidth*Img.Scale.X/speGridCount.Value),
        Round(Img.AbsWidth*Img.Scale.X),
        Round(Img.AbsHeight*Img.Scale.Y)) then
      begin
        sgPaintBox.Canvas.Pen.Color := clGray;
        DrawPolyPolyLine(sgPaintBox.Canvas.Handle, FIntPoints);
      end;
    end;
  end;

  if (Img <> nil) then
    if (not Img.Empty) and (sbShowBorder.Enabled) and (sbShowBorder.Down) then
    begin
      try
        vBMPFrame := TBitmap.Create;
        sgPaintBox.Transparent := True;
        vBMPFrame.PixelFormat := pf8bit;
        vBMPFrame.Width := sgPaintBox.Width;
        vBMPFrame.Height := sgPaintBox.Height;
        vBMPFrame.Assign(imgFrame.Picture.Bitmap);

        // draw stretched border bitmap
        sgPaintBox.Canvas.StretchDraw(Rect(0, 0, sgPaintBox.Width, sgPaintBox.Height),
          vBMPFrame);

        FillChar(vImgRect, SizeOf(TRect), #0);
        vImgRect.Left := sgPaintBox.Width div 4;
        vImgRect.Top := sgPaintBox.Height div 4;
        vImgRect.Right := vImgRect.Left + sgPaintBox.Width div 2;
        vImgRect.Bottom := vImgRect.Top + sgPaintBox.Height div 2;
        // draw stretched CAD graphic
        sgPaintBox.Canvas.StretchDraw(vImgRect, Img);
      finally
        vBMPFrame.Free;
      end;
    end;
end;

procedure TForm1.sgPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  vPt: TFPoint;

  function DoCADPosition(PointOnScr: TPoint): TFPoint;
  var
    vImg: TsgDXFImage;
    vRect: TRect;
  begin
    vImg := TsgDXFImage(sgPaintBox.Picture.Graphic);
    vRect := sgPaintBox.PictureRect;
    Result := vImg.GetCADCoords(PointOnScr.X / (vRect.Right - vRect.Left),
       PointOnScr.Y / (vRect.Bottom - vRect.Top));
  end;

begin
  if sgPaintBox.Empty then Exit;
  if sgPaintBox.Picture.Graphic is TsgDXFImage then
  begin
    vPt := GetMouseCoord(X, Y);//GetRealPointUsingsgImagePoint(sgPaintBox, X, Y);//DoCADPosition(Point(X, sgPaintBox.Height - Y));
    pnlCoords.Caption := Format('(%.3f; %.3f; 0.000)', [vPt.X, vPt.Y]);
  end;
end;

procedure TForm1.BtnPrint1Click(Sender: TObject);
const
  PO: array[Boolean] of TPrinterOrientation = (poPortrait,poLandscape);
  koef = 25.4;
  ScaleFactor = 0.5;
var
  PxlsX, PxlsY: Double;
  W, H: Integer;
begin
  Printer.Orientation := PO[sgPaintBox.Picture.Graphic.Width >
    sgPaintBox.Picture.Graphic.Height];
  if PrintDialog1.Execute then
  begin
    SetNullWidth(sgPaintBox.Picture.Graphic, 3);
    W := sgPaintBox.Picture.Graphic.Width;
    H := sgPaintBox.Picture.Graphic.Height;
    PxlsX := 1;
    PxlsY := 1;
    if sgPaintBox.Picture.Graphic is TsgDXFImage then
    begin
      PxlsX := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
      PxlsY := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
      if TsgDXFImage(sgPaintBox.Picture.Graphic).Millimetres then
      begin
        PxlsX := PxlsX / koef;
        PxlsY := PxlsY / koef;
      end;
    end;
    Printer.Title := 'CAD Image VCL printing 1:1';
    Printer.BeginDoc;
    Printer.Canvas.StretchDraw(Rect(0, 0, Round(PxlsX * W * ScaleFactor),
                               Round(PxlsY * H * ScaleFactor)),
      sgPaintBox.Picture.Graphic);
    Printer.EndDoc;
    RestoreNullWidth(sgPaintBox.Picture.Graphic);
    sgPaintBox.Repaint;
  end;
end;

procedure TForm1.btnFitToScreenClick(Sender: TObject);
begin
  sgPaintBox.Align := alNone;
  sgPaintBox.Align := alClient;
  sgPaintBoxScaling(Self);
end;

procedure TForm1.btnIsWithoutBorderClick(Sender: TObject);
begin
  if sgPaintBox.Empty or not ( sgPaintBox.Picture.Graphic is TsgDXFImage ) then Exit;
  Img.IsWithoutBorder := not Img.IsWithoutBorder;
end;

procedure TForm1.SetBtnEnable(AEnable: Boolean);
var
  I: Integer;

begin
  for I := 0 to ComponentCount - 1 do
    if (Components[I] is TSpeedButton) and (Components[I].Tag = 1) then
      TSpeedButton(Components[I]).Enabled := AEnable;
end;

procedure TForm1.btnShowLineWeightClick(Sender: TObject);
begin
  Img.IsShowLineWeight := btnShowLineWeight.Down;
end;

procedure TForm1.btnSplittedArcClick(Sender: TObject);
begin
  Img.UseWinEllipse := not btnSplittedArc.Down;
end;

procedure TForm1.btnDrawAllColorClick(Sender: TObject);
begin
  if btnDrawAllColor.Down then
    Img.DrawMode := dmNormal
  else
    Img.DrawMode := dmBlack;
end;

procedure TForm1.SetImgOpt;
begin
  btnShowLineWeightClick(nil);
  btnSplittedArcClick(nil);
  btnDrawAllColorClick(nil);
  btnWhiteBackgroundClick(nil);
end;

procedure TForm1.btnWhiteBackgroundClick(Sender: TObject);
begin
  if btnWhiteBackground.Down then
  begin
    Img.BackgroundColor := clWhite;
    Img.DefaultColor := clBlack;
  end
  else
  begin
    Img.BackgroundColor := clBlack;
    Img.DefaultColor := clWhite;
  end;
end;

procedure TForm1.sb3DAxesClick(Sender: TObject);
begin
  sb3DAxes.Down := sb3DAxes.Down or False;
  if sb3DAxes.Down then
    Img.IsDraw3DAxes := True
  else
    Img.IsDraw3DAxes := False;
  sgPaintBox.Invalidate;
end;


procedure TForm1.sb3DOrbitClick(Sender: TObject);
begin
  sb3DOrbit.Down := sb3DOrbit.Down or False;
  if sb3DOrbit.Down then
  begin
    Orbit3D.CADImage := TsgDXFImage(sgPaintBox.Picture.Graphic);
    Orbit3D.Visible := True;
    Orbit3D.Parent.Repaint;
  end
  else
  begin
    Orbit3D.CADImage := nil;
    Orbit3D.Visible := False;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if Assigned(Orbit3D) and (Orbit3D.Visible) then
    Orbit3D.Refresh;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FOptions.Free;
  Orbit3D.Free;
  Orbit3D := nil;
  FIntPoints.Free;
{$IFDEF SGDEL_4}
  FObjectSnap.Free;
{$ENDIF}
end;

procedure TForm1.BtnPrint2Click(Sender: TObject);
var
  P: TPoint;
begin
  Win32Check(Windows.GetCursorPos(P));
  PopupMenu1.Popup(P.X, P.Y);
end;

procedure TForm1.miSaveAsBigEMFClick(Sender: TObject);
var
  {$IFDEF SGDEL_4}
  vM: TMetafile;
  {$ENDIF}
  vCAD: TsgDXFImage;
begin
  if sgPaintBox.Empty or not (sgPaintBox.Picture.Graphic is TsgDXFImage) then Exit;
  SavePictureDialogEMF.FileName := '*.emf';
  if not SavePictureDialogEMF.Execute then Exit;
  if LowerCase(ExtractFileExt(SavePictureDialogEMF.FileName)) <> '.emf' then
    SavePictureDialogEMF.FileName := ChangeFileExt(SavePictureDialogEMF.FileName, '.emf');
  vCAD := TsgDXFImage(sgPaintBox.Picture.Graphic);
  {$IFNDEF SGDEL_4}
  vCAD.ExportToMetafile(SavePictureDialogEMF.FileName,
    3276700, Round(3276700 * vCAD.AbsHeight / vCAD.AbsWidth));
  {$ELSE}
  try
    vM := vCAD.ExportToMetafile(3276700);
    vM.SaveToFile(SavePictureDialogEMF.FileName);
  finally
    vM.Free;
  end;
  {$ENDIF}
end;

procedure TForm1.ViewLayouts;
var
  I: Integer;
begin
  if Img <> nil then
  begin
    cbLayouts.Items.Clear;
    for I := 0 to Img.LayoutsCount - 1 do
      cbLayouts.Items.AddObject(Img.Layouts[I].Name, Img.Layouts[I]);
    cbLayouts.ItemIndex := Img.Converter.DefaultLayoutIndex;
    Img.CurrentLayout := Img.Layouts[cbLayouts.ItemIndex];
    pnlLayouts.Visible := True;
//    Enable3DAxes(Img.CurrentLayout.IsModel);
//    Enable3DOrbit(Img.CurrentLayout.IsModel);
    Enable3DAxes(Img.CurrentLayout.CADSpace <> csUndefined);
    Enable3DOrbit(Img.CurrentLayout.CADSpace <> csUndefined);
  end;
end;

procedure TForm1.Enable3DAxes(AIsEnabled: Boolean);
begin
  sb3DAxes.Down := False;
  sb3DAxes.Enabled := AIsEnabled;
  if AIsEnabled = False then
    Img.IsDraw3DAxes := AIsEnabled;
end;

procedure TForm1.Enable3DOrbit(AIsEnabled: Boolean);
begin
  if Orbit3D <> nil then
    Orbit3D.Visible := False;
  sb3DOrbit.Down := False;
  sb3DOrbit.Enabled := AIsEnabled;
end;

procedure TForm1.cbLayoutsChange(Sender: TObject);
begin
  if cbLayouts.Items.Objects[cbLayouts.ItemIndex] <> nil then
  begin
    Img.CurrentLayout := Img.Layouts[cbLayouts.ItemIndex];
    sbDrawingBoxClick(nil);
    sgPaintBox.Width := Img.Width;
    sgPaintBox.Height := Img.Height;
    sgPaintBox.Align := alClient;
    sgPaintBox.Invalidate;
//    Enable3DAxes(Img.CurrentLayout.IsModel);
//    Enable3DOrbit(Img.CurrentLayout.IsModel);
    Enable3DAxes(Img.CurrentLayout.CADSpace <> csUndefined);
    Enable3DOrbit(Img.CurrentLayout.CADSpace <> csUndefined);
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if TreeView1.Items.Count = 0 then
    LoadStructure;
end;

procedure TForm1.speNumPartsCircleChange(Sender: TObject);
var
  Val: Integer;
begin
  if TSpinEdit(Sender).Text = '' then Exit;
  try
    Val := speNumPartsCircle.Value;
  except
    speNumPartsCircle.Value := iDefaultNumberOfCircleParts;
    Val := iDefaultNumberOfCircleParts;
  end;
  if (Val >= 2) then
  begin
    Img.Converter.NumberOfPartsInCircle := Val;
    sgPaintBox.Invalidate;
  end
  else
    speNumPartsCircle.Value := 2;
end;

procedure TForm1.speNumPartsSplineChange(Sender: TObject);
var
  Val: Integer;
begin
  if TSpinEdit(Sender).Text = '' then Exit;
  try
    Val := speNumPartsSpline.Value;
  except
    speNumPartsSpline.Value := iDefaultNumberOfSplineParts;
    Exit;
  end;
  if (Val >= 2) then
  begin
    Img.Converter.NumberOfPartsInSpline := Val;
    sgPaintBox.Invalidate;
  end
  else
    speNumPartsSpline.Value := 2;
end;

procedure TForm1.Showpoint1Click(Sender: TObject);
var
  Form2: TForm2;
begin
  Form2 := TForm2.Create(Self);
  try
    Form2.ShowModal;
  finally
    Form2.Free;
  end;
end;

procedure TForm1.Findtext1Click(Sender: TObject);
var
  Form3: TForm3;
begin
  Form3 := TForm3.Create(Self);
  try
    Form3.ShowModal;
  finally
    Form3.Free;
  end;
end;

procedure TForm1.Reopenwithsameview1Click(Sender: TObject);
var
  FPoint: TFPoint;
  vRect: TRect;
  vScale: Extended;
  vLayoutName: String;
  ImgWidth, ImgHeight, ImgLeft, ImgTop: Integer;
  I: Integer;
begin
  if sgPaintBox.Picture.Graphic is TsgDXFImage then
  begin
    ImgWidth := 0;
    ImgHeight := 0;
    ImgLeft := 0;
    ImgTop := 0;
    vRect := sgPaintBox.PictureRect;
    vLayoutName := TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout.Name;
    if ((vRect.Right - vRect.Left) <= sgPaintBox.Width) or ((vRect.Bottom - vRect.Top) <= sgPaintBox.Height) then
      FPoint := TsgDXFImage(sgPaintBox.Picture.Graphic).GetCADCoords((sgPaintBox.Parent.Width div 2 - sgPaintBox.Left) / (vRect.Right - vRect.Left),
                                                                    (sgPaintBox.Height - (sgPaintBox.Parent.Height / 2 - sgPaintBox.Top)) / (vRect.Bottom - vRect.Top))
    else
    begin
      FPoint := TsgDXFImage(sgPaintBox.Picture.Graphic).GetCADCoords((-(vRect.Left  - sgPaintBox.Left) + sgPaintBox.Parent.Width div 2  - sgPaintBox.Left) / (vRect.Right - vRect.Left),
                                                                 1 - (sgPaintBox.Parent.Height / 2 - sgPaintBox.Top - (vRect.Top - sgPaintBox.Top)) / (vRect.Bottom - vRect.Top));
      ImgWidth := sgPaintBox.Width;
      ImgHeight := sgPaintBox.Height;
      ImgLeft := sgPaintBox.Left;
      ImgTop := sgPaintBox.Top;
    end;
    vScale := sgPaintBox.Scale;
    MICloseClick(Self);
    Open(FFileName);
    for I := 0 to TsgDXFImage(sgPaintBox.Picture.Graphic).LayoutsCount - 1 do
      if TsgDXFImage(sgPaintBox.Picture.Graphic).Layouts[I].Name = vLayoutName then
        TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout := TsgDXFImage(sgPaintBox.Picture.Graphic).Layouts[I];
    if ImgWidth <> 0 then
    begin
      //sgPaintBox.Width := ImgWidth;
      //sgPaintBox.Height := ImgHeight;
      sgPaintBox.Align := alNone;
      sgPaintBox.SetBounds(ImgLeft, ImgTop, ImgWidth, ImgHeight);
    end;
    sgPaintBox.ShowPoint(FPoint, vScale * 100, TsgDXFImage(sgPaintBox.Picture.Graphic).Extents);
  end
  else
    ShowMessage('It is not CAD file. This operation does not work.');
end;

procedure TForm1.miFontsClick(Sender: TObject);
begin
  if FontsOptionsExecute(FOptions, Form1) and (FFileName<>'') then
    Open(FFileName)
  else
    sgPaintBox.Invalidate;
end;

procedure TForm1.speGridCountChange(Sender: TObject);
begin
  sgPaintBox.Invalidate;
  sgPaintBox.Transparent := False;
end;

procedure TForm1.sbDrawingBoxClick(Sender: TObject);
begin
  if Img = nil then Exit;
  sbDrawingBox.Down := sbDrawingBox.Down or False;
  Enable3DOrbit(not sbDrawingBox.Down);
  if sbDrawingBox.Down then
    Img.DrawingBox := MakeFRect((Img.CurrentLayout.Box.Left + Img.CurrentLayout.Box.Right) / 2,
      Img.CurrentLayout.Box.Top, Img.CurrentLayout.Box.Z1, Img.CurrentLayout.Box.Right, Img.CurrentLayout.Box.Bottom, Img.CurrentLayout.Box.Z2)
  else
    Img.ResetDrawingBox;
  sgPaintBox.Width := Img.Width;
  sgPaintBox.Height := Img.Height;
  sgPaintBox.Align := alClient;
  sgPaintBox.Invalidate;
end;

procedure TForm1.ReopenwithSWisometricview1Click(Sender: TObject);
var
  vLayoutName: String;
  I: Integer;
begin
  if sgPaintBox.Picture.Graphic is TsgDXFImage then
  begin
    vLayoutName := TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout.Name;
    if FFileName = '' then Exit;
    MICloseClick(Self);
    Open(FFileName);
    for I := 0 to TsgDXFImage(sgPaintBox.Picture.Graphic).LayoutsCount - 1 do
      if TsgDXFImage(sgPaintBox.Picture.Graphic).Layouts[I].Name = vLayoutName then
        TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout := TsgDXFImage(sgPaintBox.Picture.Graphic).Layouts[I];
    //if TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout.IsModel then
    if TsgDXFImage(sgPaintBox.Picture.Graphic).CurrentLayout.CADSpace = cs3D then
    begin
      TsgDXFImage(sgPaintBox.Picture.Graphic).RotToView(vdTop);
      TsgDXFImage(sgPaintBox.Picture.Graphic).Rotate(AxisZ, 45);
      TsgDXFImage(sgPaintBox.Picture.Graphic).Rotate(AxisX, -54.735610317245345684622999669981);
    end
    else
      ShowMessage('The current layout of this file is not model. This operation does not work.');
  end
  else
    ShowMessage('It is not CAD file. This operation does not work.');
  sgPaintBox.Refresh;
end;

procedure TForm1.sbShowBorderClick(Sender: TObject);
begin
  if sbShowBorder.Down then
  begin
    if OpenBorder.Execute then
    begin
      imgFrame.Picture.LoadFromFile(OpenBorder.FileName);
      sb3DOrbit.Enabled := False;
      sb3DAxes.Enabled := False;
    end
    else
    begin
      sbShowBorder.Down := False;
      sb3DOrbit.Enabled := True;
      sb3DAxes.Enabled := True;
      sgPaintBox.Transparent := False;
    end;
  end
  else
  begin
    if not imgFrame.Picture.Bitmap.Empty then
      imgFrame.Picture.Bitmap.FreeImage;
    sgPaintBox.Transparent := False;
    sb3DOrbit.Enabled := True;
    sb3DAxes.Enabled := True;
  end;
  sgPaintBox.Invalidate;
end;

{$IFDEF SGDEL_4}
{ TSnapMarker }

procedure TSnapMarker.ClearPoint;
begin
  FPoint.X := MaxInt;
end;

procedure TSnapMarker.ClearSnap;
begin
  if FSnapped then
  begin
    FSnapped := False;
    Erase;
    FSnap := osNone;
  end;
end;

constructor TSnapMarker.Create(AsgImage: TsgImage);
begin
  FDrawAreaSize := iSnapMarkerSize;
  FRepaint := False;
  FRescaling := False;
  FsgImage := AsgImage;
  if FsgImage.Picture.Graphic is TsgDXFImage then
  begin
    FDXFImage := TsgDXFImage(FsgImage.Picture.Graphic);
    SetsgImage;
  end;
end;

destructor TSnapMarker.Destroy;
begin
  ResetsgImage;
  inherited;
end;

procedure TSnapMarker.Draw(Erase: Boolean);
var
  vPenStyle: TPenStyle;
  vPenMode: TPenMode;
  vPenWidth: Integer;
  vPenColor{, vBrushColor}: TColor;

  procedure DrawCross;
  begin
    FsgImage.Canvas.MoveTo(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y + FDrawAreaSize);
    FsgImage.Canvas.MoveTo(FPoint.X - FDrawAreaSize, FPoint.Y + FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y - FDrawAreaSize);
  end;

  procedure DrawBox;
  begin
    FsgImage.Canvas.MoveTo(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y - FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y + FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X - FDrawAreaSize, FPoint.Y + FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize);
  end;

  procedure DrawCircle;
  var
    vBS: TBrushStyle;
  begin
    vBS := FsgImage.Canvas.Brush.Style;
    try
      FsgImage.Canvas.Brush.Style := bsClear;
      //FsgImage.Canvas.Pen.Style := psSolid;
      {if fmMain.FBackGroundColor = clBlack then
        FsgImage.Canvas.Pen.Color := clBlack
      else
        FsgImage.Canvas.Pen.Color := clWhite;}
      FsgImage.Canvas.Ellipse(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize,
                              FPoint.X + FDrawAreaSize, FPoint.Y + FDrawAreaSize);
      //FsgImage.Canvas.Pen.Style := psDot;
      {if fmMain.FBackGroundColor = clBlack then
        FsgImage.Canvas.Pen.Color := clWhite
      else
        FsgImage.Canvas.Pen.Color := clBlack;}
      //FsgImage.Canvas.Ellipse(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize,
      //                        FPoint.X + FDrawAreaSize, FPoint.Y + FDrawAreaSize);
    finally
      FsgImage.Canvas.Brush.Style := vBS;
    end;
  end;

  procedure DrawInsertSnap;
  begin
    FsgImage.Canvas.MoveTo(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X - FDrawAreaSize, FPoint.Y + Round(FDrawAreaSize * 0.2));
    FsgImage.Canvas.LineTo(FPoint.X, FPoint.Y + Round(FDrawAreaSize * 0.2));
    FsgImage.Canvas.LineTo(FPoint.X, FPoint.Y + FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y + FDrawAreaSize);

    FsgImage.Canvas.LineTo(FPoint.X + FDrawAreaSize, FPoint.Y - Round(FDrawAreaSize * 0.2));
    FsgImage.Canvas.LineTo(FPoint.X, FPoint.Y - Round(FDrawAreaSize * 0.2));
    FsgImage.Canvas.LineTo(FPoint.X, FPoint.Y - FDrawAreaSize);
    FsgImage.Canvas.LineTo(FPoint.X - FDrawAreaSize, FPoint.Y - FDrawAreaSize);
  end;

begin

  //if not FSnapped then
  //  Exit;
  if Abs(FImageScale - FsgImage.Scale) > FAccuracy then
  begin
    FImageScale := FsgImage.Scale;
    ClearPoint;
  end;

  if FPoint.X = MaxInt then
    Exit;

  vPenStyle := FsgImage.Canvas.Pen.Style;
  vPenMode := FsgImage.Canvas.Pen.Mode;
  vPenWidth := FsgImage.Canvas.Pen.Width;
  vPenColor := FsgImage.Canvas.Pen.Color;
  //vBrushColor := FsgImage.Canvas.Brush.Color;
  try
    FsgImage.Canvas.Pen.Width := 1;
    FsgImage.Canvas.Pen.Style := psSolid;
    FsgImage.Canvas.Pen.Color := clWhite;
    FsgImage.Canvas.Pen.Mode := pmNot;
    //fmMain.PnlStatusLeft.Caption := fmMain.PnlStatusLeft.Caption + ' 1';
    //FsgImage.Canvas.Brush.Color := clBlack;
    case FSnap of
      osEndPt: DrawBox;
      osCenter: DrawCircle;
      osInsert: DrawInsertSnap;
    end;
  finally
    FsgImage.Canvas.Pen.Style := vPenStyle;
    FsgImage.Canvas.Pen.Mode := vPenMode;
    FsgImage.Canvas.Pen.Width := vPenWidth;
    FsgImage.Canvas.Pen.Color := vPenColor;
    //FsgImage.Canvas.Brush.Color := vBrushColor;
  end;
end;

procedure TSnapMarker.Erase;
var
  vRect: TRect;
  //I: Integer;
  //A, B: Single;

  procedure ErRect(L, R, T, B: Integer);
  begin
    vRect.Left := FsgImage.Left + FPoint.X + L;
    vRect.Right := FsgImage.Left + FPoint.X + R;
    vRect.Top := FsgImage.Top + FPoint.Y + T;
    vRect.Bottom := FsgImage.Top + FPoint.Y + B;
    InvalidateRect(FsgImage.Parent.Handle, @vRect, False);
  end;

begin
  Draw(True);
end;

procedure TSnapMarker.Repaint(Sender: TObject);
begin
  if Assigned(FImageOnPaint) then
    FImageOnPaint(Sender);
  if Abs(FImageScale - FsgImage.Scale) > FAccuracy then
  begin
    FImageScale := FsgImage.Scale;
    ClearPoint;
  end;
  {if FRescaling then
  begin
    FPoint := FDXFImage.GetPoint(FRealPoint);
    FRescaling := False;
  end;}
  if not FRepaint then
    Draw(False)
  else
    FRepaint := False;
end;

procedure TSnapMarker.Rescaling(Sender: TObject);
begin
  if Assigned(FImageOnScaling) then
    FImageOnScaling(Sender);
  FRescaling := True;
end;

procedure TSnapMarker.ResetsgImage;
begin
  if Assigned(FImageOnPaint) then
    FsgImage.OnPaint := FImageOnPaint;
  if Assigned(FImageOnScaling) then
    FsgImage.OnScaling := FImageOnScaling;
end;

procedure TSnapMarker.SetDXFImage(ADXFImage: TsgDXFImage);
begin
  FDXFImage := ADXFImage;
end;

procedure TSnapMarker.SetsgImage;
begin
  FImageOnPaint := FsgImage.OnPaint;
  FImageOnScaling := FsgImage.OnScaling;
  FsgImage.OnPaint := Repaint;
  FsgImage.OnScaling := Rescaling;
  FImageScale := FsgImage.Scale;
end;

procedure TSnapMarker.Snap(APoint: TFPoint; ASnap: TObjectSnapMode);
var
  vPoint: TPoint;
  vSnap: TObjectSnapMode;
begin
  if not Assigned(FDXFImage) then
    Exit;
  vPoint := FDXFImage.GetPoint(APoint);
  vSnap := ASnap;
  if not((Abs(vPoint.X - FPoint.X) < fAccuracy) and (Abs(vPoint.Y - FPoint.Y) < fAccuracy)
    and (vSnap = FSnap)) then
  begin
    if FSnapped then
      Erase;
    FPoint := vPoint;
    FRealPoint := APoint;
    FSnap := vSnap;
    FSnapped := True;
    Draw(False);
  end;
end;

procedure TForm1.CreateSnapObject;
begin
  if not Assigned(FSnapMarkers) then
    FSnapMarkers := TSnapMarker.Create(sgPaintBox);
end;

procedure TForm1.SetSnapMode(Value: TObjectSnapMode);
begin
  FSnapMode := Value;
  if Assigned(Img) then
    Img.SetObjectSnapMode(Value);
  if Value = osAll then
    FSnappedEntity := nil;
end;
{$ENDIF}

procedure TForm1.OSAllExecuteClick(Sender: TObject);
begin
  {$IFDEF SGDEL_4}
  CreateSnapObject;
  OSAllExecute.Checked := not OSAllExecute.Checked;
  if OSAllExecute.Checked then
    SnapMode := osAll
  else
    SnapMode := osNone;
  {$ENDIF}
end;


function TForm1.GetMouseCoord(X, Y: Integer): TFPoint;
var
  vPt: TFPoint;
{$IFDEF SGDEL_4}
  vPt2: TFPoint;
  vEntity: TsgDXFEntity;
  vSnap: TObjectSnapMode;
  X1, Y1: Integer;
{$ENDIF}
begin
{$IFDEF SGDEL_4}
  vSnap := FSnapMode;
  if sgPaintBox.Left < 0 then
    X1 := X + sgPaintBox.Left
  else
    X1 := X;
  if sgPaintBox.Top < 0 then
    Y1 := Y + sgPaintBox.Top
  else
    Y1 := Y;
  vPt2 := FObjectSnap.GetSnapPoint(Point(X1, Y1), vSnap, vEntity);
  FSnappedEntity := vEntity;
  if vSnap = osNone then
  begin
{$ENDIF}
    vPt := GetRealPointUsingsgImagePoint(sgPaintBox, X, Y);
{$IFDEF SGDEL_4}
    if Assigned(FSnapMarkers) then
      FSnapMarkers.ClearSnap;
  end
  else
  begin
    if Img is TsgHPGLImage then
      vPt := TsgHPGLImage(Img).ConvertHPGLStepsToMM(vPt2)
    else
      vPt := vPt2;
    if Assigned(FSnapMarkers) then
      FSnapMarkers.Snap(vPt2, vSnap);
  end;
{$ENDIF}
  Result := vPt;
end;

{ TForm1.SaveToDXF

  Saving in DXF format using a metafile.
  A structure of the CAD file to be saved can change.
  Besides, ARC, SPLINE, etc. can be saved as POLYLINEs.  }
procedure TForm1.SaveToDXF(AFileName: string);
{$IFDEF SG_USEDXFEXPORT}
var
  E: TsgDXFExport;
  vMet: TMetafile;
  vGr: TGraphic;
  vOffX, vOffY, vUSize: TsgFloat;
{$ENDIF}
begin
  {$IFDEF SG_USEDXFEXPORT}
  vGr := sgPaintBox.Picture.Graphic;
  E := TsgDXFExport.Create;
  try
    E.IsParseWhite := True;// False
    if not ((vGr is TsgDXFImage) or (vGr is TMetafile)) then
    begin
      ShowMessage(sNotVectorial);
      Exit;
    end
    else
    begin
      if not (vGr is TsgDXFImage) then
      begin
        E.Use01MM := False;
        E.Canvas.StretchDraw(Rect(0, 0, vGr.Width, vGr.Height), vGr);
        E.EndDraw;
      end
      else
      begin
        vMet := TsgDXFImage(vGr).ExportToMetafile(vOffX, vOffY, vUSize);
        DXFExport.OffsetX := vOffX;
        DXFExport.OffsetY := vOffY;
        E.UnitSize := vUSize;
        E.LoadFromMetafile(vMet);
        vMet.Free;
      end;
    end;
    E.SaveToFile(AFileName);
  finally
    E.Free;
  end;
  {$ELSE}
  MessageBox(0, PChar('This function is available with the DXFExport VCL only.'), 'WARNING', MB_ICONWARNING);
  {$ENDIF}
end;

end.
